/*************************************************************************

                          st0rm SGE Source Code

                          (c)1998 David Sanchez
                           st0rm@melodysoft.com

                        Released on 17th March 1999
        

Este codigo fuente lo puedes utilizar para:

- Usarlo como fuente de informacin para tus proyectos.
- Continuar el proyecto st0rm.
- Empezar un emulador desde 0 teniendo este como base.

Lo nico que pido si te es util y lo usas, es que lo menciones en tu
proyecto.

Tendras que perdonarme la falta de comentarios y el desorden total,
aun asi puede ser util.


COMENTARIOS EN README.TXT

*************************************************************************/


#include <dos.h>
#include <i86.h>
#include <stdio.h>
#include <malloc.h>
#include <conio.h>
#include <time.h>
#include <mem.h>
#include "vga.h"
#include "misc.h"
#include "header.h"
#include "st0rm.h"
#include "memory.h"
#include "m68k.h"
#include "m68misc.h"
#include "vdp.h"
#include "genio.h"
#include "gensnd.h"




extern char            *sizes[];
struct _io_             io;


u_char                  req_joy1        = 0;
u_char                  req_joy2        = 0;
u_char                  req_but1        = 0;
u_char                  req_but2        = 0;

u_char                  z80_stop        = 1;


void ResetIO (void) {

  io.version = io.hw_version;
  if (io.hw_version == 1) io.version |= 0x40;
  if (io.hw_version == 1 || io.hw_version == 2) io.version |= 0x80;

  req_joy1 = 1;
  req_joy2 = 1;

  io.m68k_addr          = 0;
  io.z80_bus_req        = 1;
  io.z80_reset          = 0;
}

u_long ReadIOPort (u_long addr, u_short size) {

  u_char        joy             = 0;
  u_char        but             = 0;
  static char   z80_pass        = 0;


  if (addr == 0xa10003) {

        if (keys[2])            frame_skip = 1;
        if (keys[3])            frame_skip = 2;
        if (keys[4])            frame_skip = 3;
        if (keys[5])            frame_skip = 4;

        if (keys[KEY_UP])       joy |= 1;
        if (keys[KEY_DOWN])     joy |= 2;
        if (keys[KEY_LEFT])     joy |= 4;
        if (keys[KEY_RIGHT])    joy |= 8;

        if (keys[KEY_ENTER])    but |= 0x80;
        if (keys[0x1d])         but |= 0x40;
        if (keys[0x2a])         but |= 0x20;
        if (keys[KEY_ALT])      but |= 0x10;

        /*PrintELog ("[IO] Requested JOY1, req_joy1=%d, req_but1=%d, data=%lx %lx",
                   req_joy1, req_but1, joy, but);*/

        if (req_joy1)
                return (~(joy | but));

        if (req_but1)
                return ((~(but>>2)) & 0x30);

        PrintELog ("[IO] Unknown IO Request at %s %lx", sizes[size], addr);

        return (0);
  }

  if (addr == 0xa10005) {

        if (keys[KEY_UP])        joy |= 1;
        if (keys[KEY_DOWN])      joy |= 2;
        if (keys[KEY_LEFT])      joy |= 4;
        if (keys[KEY_RIGHT])     joy |= 8;

        if (keys[KEY_5])         but |= 0x80;
        if (keys[KEY_6])         but |= 0x40;
        if (keys[KEY_7])         but |= 0x20;
        if (keys[KEY_8])         but |= 0x10;

        if (req_joy2)
                return (~(joy | but));

        if (req_but2)
                return (~((but>>2)) & 0x30);

        PrintELog ("[IO] Unknown IO Request at %s %lx", sizes[size], addr);

        return (0);
  }

  if (addr == 0xa11100) {

        //PrintLog ("Faking Z80 at %s %lx", sizes[size], addr);

        if (!z80_stop) {
                z80_pass = ~z80_pass;
                return (0xfe | (z80_pass & 1));
        } else
                return (0);

        //return (~(io.z80_bus_req&1));
  }

  if (addr >= 0xa04000 && addr <= 0xa04fff) {

        return (FMRead (addr & 0xffff, size));
  }

  if (addr == 0xa10001) {

        PrintLog ("[IO] Writing %s version number: %x", sizes[size],
                  io.version);

        return (io.version);
  }

  if (addr == 0xa10008) {

        PrintELog ("[IO] Read at %lx", addr);
        return (0);
  }

  if (addr == 0xa1000c) {

        PrintELog ("[IO] Read at %lx", addr);
        return (0);
  }

  PrintELog ("[IO] Unknown read at %s %lx", sizes[size], addr);

  return (0);
}

void WriteIOPort (u_long addr, u_short size, u_long to_write) {

  u_long        tmp_id;


  if (addr == 0xa10003) {
        if (to_write >= 0x40) {
                //PrintELog ("Req joy1 w/%x", to_write);
                req_joy1 = 1;
                req_but1 = 0;
                return;
        }

        if (to_write <= 0x30) {
                //PrintELog ("Req but1 w/%x", to_write);
                req_joy1 = 0;
                req_but1 = 1;
                return;
        }
  }

  if (addr == 0xa10005) {
        if (to_write >= 0x40) {
                req_joy2 = 1;
                req_but2 = 0;
                return;
        }

        if (to_write <= 0x30) {
                req_joy2 = 0;
                req_but2 = 1;
                return;
        }
  }

  if ((addr == 0xa10009) && (to_write == 0x40)) {
        PrintLog ("[IO] Init Ctrl 1");
        return;
  }

  if ((addr == 0xa1000b) && (to_write == 0x40)) {
        PrintLog ("[IO] Init Ctrl 2");
        return;
  }

  if ((addr == 0xa1000d) && (to_write == 0x40)) {
        PrintLog ("[IO] Init Ctrl 3");
        return;
  }

  if (addr == 0xa11100) {
        if ((to_write == 0x100) || (to_write == 1)) {
                PrintLog ("Access to Z80 RAM Requested");
                z80_stop = 1;
                io.z80_bus_req = 1;
                return;
        }

        if (!to_write) {
                PrintLog ("Z80 Running");
                z80_stop = 0;
                io.z80_bus_req = 0;
                return;
        }
  }

  if (addr >= 0xa04000 && addr <= 0xa04fff) {

        FMWrite (addr & 0xffff, size, to_write);
        return;
  }

  if (addr == 0xa11200) {
        if (!to_write) {
                //PrintLog ("Z80 Reset on");
                //Z80_Reset();
                //z80_stop = 1;
                return;
        }

        if (to_write == 0x100) {
                //PrintLog ("Z80 Reset off");
                //z80_stop = 0;
                return;
        }
  }

  if (addr == 0xa14000) {
        tmp_id = RorLong (to_write);
        PrintLog ("ID security received: %-4.4s", &tmp_id);
        return;
  }

  PrintELog ("[IO] Unknown write to IO Port at %s %lx: %lx", sizes[size], addr,
            to_write);
}

