/*************************************************************************

                          st0rm SGE Source Code

                          (c)1998 David Sanchez
                           st0rm@melodysoft.com

                        Released on 17th March 1999
        

Este codigo fuente lo puedes utilizar para:

- Usarlo como fuente de informacin para tus proyectos.
- Continuar el proyecto st0rm.
- Empezar un emulador desde 0 teniendo este como base.

Lo nico que pido si te es util y lo usas, es que lo menciones en tu
proyecto.

Tendras que perdonarme la falta de comentarios y el desorden total,
aun asi puede ser util.


COMENTARIOS EN README.TXT

*************************************************************************/



#include <dos.h>
#include <malloc.h>
#include <i86.h>
#include <stdio.h>
#include <direct.h>
#include "gui.h"
#include "misc.h"
#include "uclock.h"



struct _mouse_          mouse;
u_long                  mouse_present;
extern GUISystem       *GUI;


struct {

        void          (*draw_func)      (DialogGUIItem *dialog_item);
        u_long        (*run_func)       (DialogGUIItem *dialog_item);
        u_long        (*mouse_func)     (DialogGUIItem *dialog_item);
        void          (*act_func)       (DialogGUIItem *dialog_item);
        void          (*free_func)      (DialogGUIItem *dialog_item);

} DialogFuncs[] = {

{ DTextDlg,     NULL,           NULL,           NULL,           NULL    },
{ DSelDlg,      NULL,           NULL,           NULL,           FSelDlg },
{ DButtonDlg,   RButtonDlg,     MButtonDlg,     NULL,           NULL    },
{ DListDlg,     RListDlg,       MListDlg,       AListDlg,       FListDlg },
{ DSelFileDlg,  RSelFileDlg,    MSelFileDlg,    ASelFileDlg,    FSelFileDlg }

};

GUISystem *InitGUISystem (u_long w, u_long h, char *v_buffer,
                          void (*flip_vga)(), u_long vga_w, u_long vga_h) {


  GUISystem    *gui_system;
  u_long        dif_h, dif_v;

  gui_system = (GUISystem *)malloc (sizeof (GUISystem));

  gui_system->w                 = w;
  gui_system->h                 = h;
  gui_system->vga_w             = w;
  gui_system->vga_h             = h;
  gui_system->v_buffer          = v_buffer;
  gui_system->flip_vga          = flip_vga;
  gui_system->char_set          = (u_long *)NormalCharSet;
  gui_system->backg_flg         = 0;

  gui_system->white_color       = 7;
  gui_system->black_color       = 0;
  gui_system->menu_color        = 1;
  gui_system->font_l_color      = 7;
  gui_system->font_h_color      = 15;
  gui_system->dialog_color      = 3;
  gui_system->tdialog_color     = 6;

  GUIMouseReset ();
  GUIMouseInit ();

  if (mouse_present) {

        dif_h = ((w - vga_w) / 2);
        dif_v = ((h - vga_h) / 2);

        GUIMouseSetPos (vga_w/2, vga_h/2);
        GUIMouseMax (dif_h, vga_w + dif_h, dif_v, vga_h + dif_v);
  }

  mouse.event           = 0;

  mouse.x = vga_w/2;
  mouse.y = vga_h/2;

  return (gui_system);
}

void FreeGUISystem (GUISystem *gui_system) {

  if (gui_system->backg_flg) FreeBitmapGUI (gui_system->backg_copy);

  free (gui_system);
  if (mouse_present) GUIMouseReset ();
}

void ShowGUI (GUISystem *gui_system) {

  u_long        xm, ym;
  Bitmap       *mouse_back;

  if (mouse_present) {

        GUIGiveMousePos (gui_system, &xm, &ym);
        mouse_back = GetBitmapGUI (gui_system, xm, ym, 16, 16);
        Draw16x16BitmapGUI (gui_system, xm, ym, MousePointer);
  }

  gui_system->flip_vga ();
          
  if (mouse_present) {
        PutFreeBitZoneGUI (mouse_back, xm, ym);
  }
}

void SetBackgGUI (GUISystem *gui_system) {

  gui_system->backg_flg = 1;

  gui_system->backg_copy = GetBitmapGUI (gui_system, 0, 0, gui_system->w,
                                         gui_system->h);
}

void FreeBackgGUI (GUISystem *gui_system) {

  gui_system->backg_flg = 0;

  FreeBitmapGUI (gui_system->backg_copy);
}

void Draw16x16BitmapGUI (GUISystem *gui_system, u_long x, u_long y,
                       u_char *bitmap) {

  char         *draw_z          = gui_system->v_buffer;
  int           cnt, line;

  draw_z       += (y * gui_system->w);
  draw_z       += x;

  for (line = 0; line < 16; line++) {

        for (cnt = 0; cnt < 8; cnt++) {

                if (*bitmap >> 4)
                        *draw_z++ = (*bitmap >> 4);
                else
                        draw_z++;

                if (*bitmap & 0xf)
                        *draw_z++ = (*bitmap & 0xf);
                else
                        draw_z++;

                bitmap++;
        }

        draw_z         += (gui_system->w - 16);
  }
}

void DrawBitmapGUI (GUISystem *gui_system, u_long x, u_long y,
                       u_char *bitmap, u_long w, u_long h) {

  char         *draw_z          = gui_system->v_buffer;
  int           cnt, line;

  draw_z       += (y * gui_system->w);
  draw_z       += x;

  for (line = 0; line < h; line++) {

        for (cnt = 0; cnt < (w/2); cnt++) {

                if (*bitmap >> 4)
                        *draw_z++ = (*bitmap >> 4);
                else
                        draw_z++;

                if (*bitmap & 0xf)
                        *draw_z++ = (*bitmap & 0xf);
                else
                        draw_z++;

                bitmap++;
        }

        draw_z         += (gui_system->w - w);
  }
}


static u_long DrawCharXYGUI (GUISystem *gui_system, u_long x, u_long y,
                    u_long colour, char to_draw) {

  char         *draw_z          = gui_system->v_buffer;
  u_long       *char_ptr        = gui_system->char_set;
  long          char_despl      = ((to_draw - 32) * 8);
  u_char       *tmp_ptr;
  u_long        char_line;
  int           cnt, line;
  u_long        cnt_np          = 0;
  u_long        width_p         = 0;
  u_long        r_width_p       = 0;
  u_char        next_p;


  if (char_despl < 0)           char_despl = 0;
  if (char_despl > (91*8))      char_despl = 0;

  draw_z       += (y * gui_system->w);
  draw_z       += x;
  char_ptr     += char_despl;

  for (line = 0; line < 8; line++) {

        char_line       = RotateLong (*char_ptr++);
        tmp_ptr         = (char *) &char_line;

        for (cnt = 0; cnt < 4; cnt++) {

                width_p++;
                next_p = (*tmp_ptr >> 4);
                if (next_p && (next_p != 0xf))
                        *draw_z++ = (colour) ? (next_p != 1) ? \
                                    next_p : colour : next_p;
                else {
                        if (!next_p)
                                draw_z++;
                        else {
                                cnt_np++;
                                width_p--;
                        }
                }

                width_p++;
                next_p = (*tmp_ptr & 0xf);
                if (next_p && (next_p != 0xf))
                        *draw_z++ = (colour) ? (next_p != 1) ? \
                                    next_p : colour : next_p;
                else {
                        if (!next_p)
                                draw_z++;
                        else {
                                cnt_np++;
                                width_p--;
                        }
                }
                tmp_ptr++;
        }

        r_width_p       = width_p;
        width_p         = 0;
        draw_z         += (gui_system->w - 8 + cnt_np);
        cnt_np          = 0;
  }

  return (r_width_p);
}

static u_long CntCharGUI (GUISystem *gui_system, char to_draw) {

  u_long       *char_ptr        = gui_system->char_set;
  long          char_despl      = ((to_draw - 32) * 8);
  u_char       *tmp_ptr;
  u_long        char_line;
  int           cnt, line;
  u_long        cnt_np          = 0;
  u_long        width_p         = 0;
  u_long        r_width_p       = 0;
  u_char        next_p;

  if (char_despl < 0) return (0);

  char_ptr     += char_despl;

  for (line = 0; line < 8; line++) {

        char_line       = RotateLong (*char_ptr++);
        tmp_ptr         = (char *) &char_line;

        for (cnt = 0; cnt < 4; cnt++) {

                width_p++;
                next_p = (*tmp_ptr >> 4);
                if (next_p && (next_p != 0xf))
                        ;
                else {
                        if (!next_p)
                                ;
                        else {
                                cnt_np++;
                                width_p--;
                        }
                }

                width_p++;
                next_p = (*tmp_ptr & 0xf);
                if (next_p && (next_p != 0xf))
                        ;
                else {
                        if (!next_p)
                                ;
                        else {
                                cnt_np++;
                                width_p--;
                        }
                }
                tmp_ptr++;
        }

        r_width_p       = width_p;
        width_p         = 0;
        cnt_np          = 0;
  }

  return (r_width_p);
}

void DrawTextGUI (GUISystem *gui_system, u_long x, u_long y, char *to_draw) {

  while (*to_draw)
        x += DrawCharXYGUI (gui_system, x, y, 0, *to_draw++);
}

void DrawTextGUIColor (GUISystem *gui_system, u_long x, u_long y, u_long col,
                       char *to_draw) {

  while (*to_draw)
        x += DrawCharXYGUI (gui_system, x, y, col, *to_draw++);
}

u_long CntTextGUI (GUISystem *gui_system, char *to_draw) {

  u_long        cnt     = 0;

  while (*to_draw)
        cnt += CntCharGUI (gui_system, *to_draw++);

  return (cnt);
}

void DrawRectangleGUI (GUISystem *gui_system, u_long x, u_long y, u_long xf,
                       u_long yf, u_long color) {

  char         *draw_z          = gui_system->v_buffer;
  int           y_cnt, x_cnt;

  draw_z += (gui_system->w * y);
  draw_z += x;

  for (x_cnt = x; x_cnt < (xf-1); x_cnt++)
        *draw_z++ = WHITECOLOR;

  *draw_z++     = BLACKCOLOR;
  draw_z       += (gui_system->w - (xf - x));

  for (y_cnt = (y+1); y_cnt < (yf-1); y_cnt++) {

        *draw_z++ = WHITECOLOR;

        for (x_cnt = (x+1); x_cnt < (xf-1); x_cnt++)
                *draw_z++ = color;

        *draw_z++ = BLACKCOLOR;
        draw_z += (gui_system->w - (xf - x));
  }

  for (x_cnt = x; x_cnt < xf; x_cnt++)
        *draw_z++ = BLACKCOLOR;

  draw_z += (gui_system->w - (xf - x));
}

void DrawRevRectangleGUI (GUISystem *gui_system, u_long x, u_long y, u_long xf,
                          u_long yf, u_long color) {

  char         *draw_z          = gui_system->v_buffer;
  int           y_cnt, x_cnt;

  draw_z += (gui_system->w * y);
  draw_z += x;

  for (x_cnt = x; x_cnt < xf; x_cnt++)
        *draw_z++ = BLACKCOLOR;

  draw_z += (gui_system->w - (xf - x));

  for (y_cnt = (y+1); y_cnt < (yf-1); y_cnt++) {

        *draw_z++ = BLACKCOLOR;

        for (x_cnt = (x+1); x_cnt < (xf-1); x_cnt++)
                *draw_z++ = color;

        *draw_z++ = WHITECOLOR;
        draw_z += (gui_system->w - (xf - x));
  }

  for (x_cnt = x; x_cnt < xf; x_cnt++)
        *draw_z++ = WHITECOLOR;

  draw_z += (gui_system->w - (xf - x));
}

void DrawPlainRectangleGUI (GUISystem *gui_system, u_long x, u_long y,
                            u_long xf, u_long yf, u_long color) {

  char         *draw_z          = gui_system->v_buffer;
  int           y_cnt, x_cnt;

  draw_z += (gui_system->w * y);
  draw_z += x;

  for (y_cnt = y; y_cnt < yf; y_cnt++) {

        for (x_cnt = x; x_cnt < xf; x_cnt++)
                *draw_z++ = color;

        draw_z += (gui_system->w - (xf - x));
  }
}

MenuGUI *MakeMenuGUI (GUISystem *gui_system, u_long w, u_long h) {

  MenuGUI      *menu_gui;

  menu_gui      = (MenuGUI *) malloc (sizeof (MenuGUI));

  menu_gui->w   = w;
  menu_gui->h   = h;
  
  menu_gui->pos_menu    = 0;
  menu_gui->gui_system  = gui_system;
  menu_gui->menu_item   = OpenListObj (sizeof (MenuGUIItem));
  menu_gui->items       = 0;
  menu_gui->exit        = 0;

  return (menu_gui);
}

void FreeMenuGUI (MenuGUI *menu_gui) {

  MenuGUIItem          *menu_item = (MenuGUIItem *)menu_gui->menu_item->dtos;

  while (menu_item->control) {
        if (menu_item->type == M_LINK)
                FreeMenuGUI (menu_item->menu_link);
        menu_item++;
  }

  FreeListObj (menu_gui->menu_item);
  free (menu_gui);
}

void AddPlainMenuGUI (MenuGUI *menu_gui, char *title, void (*func_call)()) {

  MenuGUIItem           menu_item;

  strcpy (menu_item.title, title);

  menu_item.func_call   = func_call;
  menu_item.type        = M_PLAIN;
  menu_item.control     = 1;

  menu_gui->items++;

  AddListObj (menu_gui->menu_item, &menu_item);
}

void AddMarkMenuGUI (MenuGUI *menu_gui, char *title, u_char *mark_var) {

  MenuGUIItem           menu_item;

  strcpy (menu_item.title, title);

  menu_item.mark_var    = mark_var;
  menu_item.type        = M_MARK;
  menu_item.control     = 1;

  menu_gui->items++;

  AddListObj (menu_gui->menu_item, &menu_item);
}

void AddSelMenuGUI (MenuGUI *menu_gui, char *title, u_char *sel_var,
                    u_long sel_pos) {

  MenuGUIItem           menu_item;

  strcpy (menu_item.title, title);

  menu_item.sel_var     = sel_var;
  menu_item.sel_pos     = sel_pos;
  menu_item.type        = M_SEL;
  menu_item.control     = 1;

  menu_gui->items++;

  AddListObj (menu_gui->menu_item, &menu_item);
}

void AddLinkMenuGUI (MenuGUI *menu_gui, char *title, MenuGUI *menu_link) {

  MenuGUIItem           menu_item;

  strcpy (menu_item.title, title);

  menu_item.menu_link   = menu_link;
  menu_item.type        = M_LINK;
  menu_item.control     = 1;

  menu_gui->items++;

  AddListObj (menu_gui->menu_item, &menu_item);
}

void AddSepMenuGUI (MenuGUI *menu_gui) {

  MenuGUIItem           menu_item;

  menu_item.title[0]    = 0;
  menu_item.type        = M_SEP;
  menu_item.control     = 1;

  menu_gui->items++;

  AddListObj (menu_gui->menu_item, &menu_item);
}

void DrawMenuGUIItem (MenuGUI *menu_gui, u_long y, MenuGUIItem *menu_item,
                      u_long state);
void GoMenuGUIItem (MenuGUI *menu_gui, MenuGUIItem *menu_item,
                    u_long mouse_flg);

static MenuGUIItem *GiveMenuGUIItem (MenuGUI *menu_gui, u_long pos_menu) {

  return ((MenuGUIItem *)menu_gui->menu_item->dtos + pos_menu);
}

static long CheckMouseMenuGUI (MenuGUI *menu_gui) {

  u_long        x, y;
  MenuGUIItem  *tmp_item;
  u_long        tmp_pos;

  if (!mouse_present) return -1;

  GUIGiveMousePos (menu_gui->gui_system, &x, &y);

  if ((x < menu_gui->x) || (x > menu_gui->xf)) return -1;
  if ((y < menu_gui->y) || (y > menu_gui->yf)) return -1;

  tmp_pos       = ((y - menu_gui->y - 2) / 12);

  if (tmp_pos > (menu_gui->items-1)) return -1;

  tmp_item      = GiveMenuGUIItem (menu_gui, tmp_pos);

  if (tmp_item->type != M_SEP)
        return (tmp_pos);
  else
        return -2;

  return -1;
}

static void DrawMenuGUIItems (MenuGUI *menu_gui) {

  u_long        py              = menu_gui->y + 2;
  MenuGUIItem  *menu_item       = (MenuGUIItem *) menu_gui->menu_item->dtos;

  while (menu_item->control) {
        DrawMenuGUIItem (menu_gui, py, menu_item++, 0);
        py += 12;
  }
}

void RunMenuGUI (MenuGUI *menu_gui, u_long x, u_long y, u_long type) {

  MenuGUIItem  *menu_item       = (MenuGUIItem *) menu_gui->menu_item->dtos;
  MenuGUIItem  *tmp_item;
  GUISystem    *gui_system      = menu_gui->gui_system;
  u_long        py;
  u_long        fy;
  u_long        key;
  u_char        ch_flg          = 0;
  u_long        pos_ant;
  long          despl           = 0;
  long          tmp_pos;
  Bitmap       *back;


  menu_gui->y   = y;
  menu_gui->x   = x;
  menu_gui->yf  = (y + menu_gui->h);
  menu_gui->xf  = (x + menu_gui->w);

  py = fy = (menu_gui->y + 2);

/*if (type == MAIN_MENU) {

        back = GetBitmapGUI (menu_gui->gui_system, x, y-12, menu_gui->w,
                             menu_gui->h+12);

        DrawRectangleGUI (menu_gui->gui_system, menu_gui->x, menu_gui->y-12,
                          menu_gui->xf, menu_gui->yf, MENUCOLOR);
        DrawPlainRectangleGUI (menu_gui->gui_system, menu_gui->x+2,
                               menu_gui->y-10, menu_gui->xf-2, menu_gui->y,
                               TDIALOGCOLOR);
        DrawTextGUIColor (menu_gui->gui_system, menu_gui->x+11,
                          menu_gui->y-9, FONTHCOLOR, "Main Menu");

  } else {*/

        back = GetBitmapGUI (menu_gui->gui_system, x, y, menu_gui->w,
                             menu_gui->h);

        DrawRectangleGUI (menu_gui->gui_system, menu_gui->x, menu_gui->y,
                          menu_gui->xf, menu_gui->yf, MENUCOLOR);
/*}*/

  DrawMenuGUIItems (menu_gui);

  while (1) {
        DrawMenuGUIItem (menu_gui, fy+(menu_gui->pos_menu*12),
                         GiveMenuGUIItem (menu_gui, menu_gui->pos_menu), 1);
        ShowGUI (menu_gui->gui_system);

        ch_flg          = 0;
        pos_ant         = menu_gui->pos_menu;


        if ((key = SKbHited ()) != 0) {

                switch (key) {
                        case KEY_DOWN  : ch_flg = 1;
                                         menu_gui->pos_menu++;
                                         if (menu_gui->pos_menu > \
                                                (menu_gui->items-1))
                                                        menu_gui->pos_menu = 0;
                                         tmp_item = GiveMenuGUIItem (menu_gui,
                                                        menu_gui->pos_menu);
                                         if (tmp_item->type == M_SEP)
                                                menu_gui->pos_menu++;
                                         break;
                        case KEY_UP    : ch_flg = 1;
                                         menu_gui->pos_menu--;
                                         if (menu_gui->pos_menu < 0)
                                                menu_gui->pos_menu = (menu_gui->items-1);
                                         tmp_item = GiveMenuGUIItem (menu_gui,
                                                        menu_gui->pos_menu);
                                         if (tmp_item->type == M_SEP)
                                                menu_gui->pos_menu--;
                                         break;
                        case KEY_ENTER :
                                         GoMenuGUIItem (menu_gui, (MenuGUIItem *) \
                                                        menu_gui->menu_item->dtos + \
                                                        menu_gui->pos_menu, 0);
                                         if (menu_gui->exit) {
                                                menu_gui->exit = 0;
                                                PutFreeBitZoneGUI (back, x, y);
                                                return;
                                         }
                                         break;
                        case KEY_ESC   : PutFreeBitZoneGUI (back, x, y);
                                         return;
                }
        }

        if (ch_flg || (mouse.event && M_LDOWN)) {
                tmp_item = (MenuGUIItem *)menu_gui->menu_item->dtos + \
                           pos_ant;
                DrawMenuGUIItem (menu_gui, fy+(pos_ant*12), tmp_item, 0);
                ch_flg = 0;
        }

        if (mouse.event && M_LDOWN) {
                if ((tmp_pos = CheckMouseMenuGUI (menu_gui)) > -1) {
                        menu_gui->pos_menu = (u_long)tmp_pos;
                        GoMenuGUIItem (menu_gui, GiveMenuGUIItem (menu_gui,
                                       menu_gui->pos_menu), 1);
                        if (menu_gui->exit) {
                                menu_gui->exit = 0;
                                PutFreeBitZoneGUI (back, x, y);
                                return;
                        }
                } else if (tmp_pos == -1) {
                        if (type == CHILD_MENU) {
                                PutFreeBitZoneGUI (back, x, y);
                                return;
                        }
                }
        }
  }
}

static void DrawMenuGUIItem (MenuGUI *menu_gui, u_long y,
                             MenuGUIItem *menu_item, u_long state) {

  GUISystem    *gui_system      = menu_gui->gui_system;
  void        (*draw_func)()    = (state) ? DrawRectangleGUI : \
                                            DrawPlainRectangleGUI;

  if (menu_item->type == M_SEP) {
        DrawPlainRectangleGUI (menu_gui->gui_system, menu_gui->x+4, y+6,
                               menu_gui->xf-4, y+7, BLACKCOLOR);
        return;
  }

  draw_func (menu_gui->gui_system, menu_gui->x+2, y+1,
             menu_gui->xf-2, y+12, MENUCOLOR);

  DrawTextGUIColor (menu_gui->gui_system, menu_gui->x+10, y+2,
                   (state) ? FONTHCOLOR : FONTLCOLOR, menu_item->title);

  if (menu_item->type == M_LINK) {
        DrawCharXYGUI (menu_gui->gui_system, menu_gui->xf-12, y+2,
                      (state) ? FONTHCOLOR : FONTLCOLOR, '>');

  } else if (menu_item->type == M_MARK) {

        if (menu_item->mark_var && (*menu_item->mark_var))
                DrawCharXYGUI (menu_gui->gui_system, menu_gui->x+4, y+2,
                              (state) ? FONTHCOLOR : FONTLCOLOR, '$');

  } else if (menu_item->type == M_SEL) {
        if (menu_item->sel_var && (*menu_item->sel_var == menu_item->sel_pos))
                DrawCharXYGUI (menu_gui->gui_system, menu_gui->x+4, y+2,
                              (state) ? FONTHCOLOR : FONTLCOLOR, '$');
  }
}

static void GoMenuGUIItem (MenuGUI *menu_gui, MenuGUIItem *menu_item,
                           u_long mouse_flg) {

  GUISystem    *gui_system      = menu_gui->gui_system;
  Bitmap       *backg_copy;
  u_long        y               = (menu_gui->y+2+(menu_gui->pos_menu*12));

  DrawRevRectangleGUI (menu_gui->gui_system, menu_gui->x+2, y+1,
                menu_gui->xf-2, y+12, MENUCOLOR);
  DrawTextGUIColor (menu_gui->gui_system, menu_gui->x+11, y+2, FONTLCOLOR,
                menu_item->title);

  ShowGUI (menu_gui->gui_system);

  if (mouse_flg) {

        while (M_LDOWN) ShowGUI (menu_gui->gui_system);
        if (CheckMouseMenuGUI(menu_gui) != menu_gui->pos_menu) return;
  }

  switch (menu_item->type) {

        case M_PLAIN :
                      if (menu_item->func_call) {
                                if (gui_system->backg_flg) {
                                        backg_copy = GetBitmapGUI (gui_system,
                                                        0, 0, gui_system->w,
                                                        gui_system->h);
                                        PutBitZoneGUI (gui_system->backg_copy,
                                                       0, 0);
                                }
                                menu_item->func_call (menu_gui->gui_system);
                                if (gui_system->backg_flg)
                                        PutFreeBitZoneGUI (backg_copy, 0, 0);
                      }
                      break;
        case M_MARK  :
                      if (menu_item->mark_var)
                                *menu_item->mark_var = ~*menu_item->mark_var;
                      break;
        case M_SEL   :
                      if (menu_item->sel_var) {
                                *menu_item->sel_var = menu_item->sel_pos;
                                DrawMenuGUIItems (menu_gui);
                      }
                      break;
        case M_LINK  :
                      if (menu_item->menu_link)
                                RunMenuGUI (menu_item->menu_link,
                                            menu_gui->xf-10, y+5, CHILD_MENU);
                      break;
  }
}

DialogGUI *MakeDialogGUI (GUISystem *gui_system, char *title, u_long w,
                          u_long h) {

  DialogGUI    *dialog_gui;

  dialog_gui    = (DialogGUI *) malloc (sizeof (DialogGUI));

  dialog_gui->w = w;
  dialog_gui->h = h;

  dialog_gui->pos_dlg           = 0;
  dialog_gui->gui_system        = gui_system;
  dialog_gui->dialog_item       = OpenListObj (sizeof (DialogGUIItem));
  dialog_gui->items             = 0;
  dialog_gui->way               = DW_DOWN;
  dialog_gui->parse_data        = NULL;

  strcpy (dialog_gui->title, title);

  return (dialog_gui);
}

void AddDialogGUI (DialogGUI *dialog_gui, u_long type, void *dtos) {

  DialogGUIItem         dialog_item;

  dialog_item.type              = type;
  dialog_item.dialog_gui        = dialog_gui;
  dialog_item.dtos              = dtos;
  dialog_item.control           = 1;
  dialog_item.pos               = dialog_gui->items;

  dialog_gui->items++;

  AddListObj (dialog_gui->dialog_item, &dialog_item);
}

void FreeDialogGUI (DialogGUI *dialog_gui) {

  DialogGUIItem        *dialog_item = (DialogGUIItem *) \
                                      dialog_gui->dialog_item->dtos;

  while (dialog_item->control) {
        if (DialogFuncs[dialog_item->type].free_func)
                DialogFuncs[dialog_item->type].free_func (dialog_item);
        free (dialog_item->dtos);

        dialog_item++;
  }

  PutFreeBitZoneGUI (dialog_gui->background, dialog_gui->x,
                     dialog_gui->y - 12);
  
  FreeListObj (dialog_gui->dialog_item);
  free (dialog_gui);
}

static void DialogGUICloseUp (DialogGUI *dialog_gui, u_long y) {

  GUISystem    *gui_system      = dialog_gui->gui_system;

  DrawRectangleGUI (dialog_gui->gui_system, dialog_gui->xf-13, y+3,
                    dialog_gui->xf-3, y+11, DIALOGCOLOR);
  DrawBitmapGUI (dialog_gui->gui_system, dialog_gui->xf-11, y+4,
                 CloseButtonBitmap, 6, 5);
}

static void DialogGUICloseDown (DialogGUI *dialog_gui, u_long y) {

  GUISystem    *gui_system      = dialog_gui->gui_system;

  DrawRevRectangleGUI (dialog_gui->gui_system, dialog_gui->xf-13, y+3,
                       dialog_gui->xf-3, y+11, DIALOGCOLOR);
  DrawBitmapGUI (dialog_gui->gui_system, dialog_gui->xf-10, y+5,
                 CloseButtonBitmap, 6, 5);
}

void DrawDialogGUI (DialogGUI *dialog_gui, u_long x, u_long y) {

  GUISystem            *gui_system  = dialog_gui->gui_system;
  DialogGUIItem        *dialog_item = (DialogGUIItem *) \
                                       dialog_gui->dialog_item->dtos;

  if (!x) x = (dialog_gui->gui_system->w/2) - (dialog_gui->w/2);
  if (!y) y = (dialog_gui->gui_system->h/2) - (dialog_gui->h/2);

  dialog_gui->x         = x;
  dialog_gui->y         = (y + 12);
  dialog_gui->xf        = (x + dialog_gui->w);
  dialog_gui->yf        = (y + dialog_gui->h + 12);

  dialog_gui->background = GetBitmapGUI (dialog_gui->gui_system, x, y,
                                         dialog_gui->w, dialog_gui->h+12);

  DrawRectangleGUI (dialog_gui->gui_system, x, y, dialog_gui->xf,
                    dialog_gui->yf, DIALOGCOLOR);
  DrawPlainRectangleGUI (dialog_gui->gui_system, x+2, y+2, dialog_gui->xf-2,
                         y+12, TDIALOGCOLOR);

  DialogGUICloseUp (dialog_gui, y);

  DrawTextGUIColor (dialog_gui->gui_system, x+6, y+3, FONTHCOLOR,
                    dialog_gui->title);

  while (dialog_item->control) {
        if (DialogFuncs[dialog_item->type].draw_func)
                DialogFuncs[dialog_item->type].draw_func(dialog_item);
        dialog_item++;
  }
}

static void DialogGUIMoveWindow (DialogGUI *dialog_gui) {

  Bitmap       *dialog;
  u_long        xm, ym;
  u_long        dif_x, dif_y;


  GUIGiveMousePos (dialog_gui->gui_system, &xm, &ym);

  dialog        = GetBitmapGUI (dialog_gui->gui_system, dialog_gui->x,
                                dialog_gui->y-12, dialog_gui->w,
                                dialog_gui->h+12);

  dif_x         = (xm - dialog_gui->x);
  dif_y         = (ym - dialog_gui->y - 12);

  while (M_LDOWN) {

        PutFreeBitZoneGUI (dialog_gui->background, dialog_gui->x,
                           dialog_gui->y-12);
        GUIGiveMousePos (dialog_gui->gui_system, &xm, &ym);

        dialog_gui->y   = (ym - dif_y - 12);
        dialog_gui->yf  = (dialog_gui->y + dialog_gui->h);
        dialog_gui->x   = (xm - dif_x);
        dialog_gui->xf  = (dialog_gui->x + dialog_gui->w);

        while (dialog_gui->xf > dialog_gui->gui_system->w) {
                dialog_gui->xf--;
                dialog_gui->x--;
        }

        while (dialog_gui->x < 0) {
                dialog_gui->xf++;
                dialog_gui->x++;
        }

        while (dialog_gui->yf > dialog_gui->gui_system->h) {
                dialog_gui->yf--;
                dialog_gui->y--;
        }

        while ((dialog_gui->y-12) < 0) {
                dialog_gui->yf++;
                dialog_gui->y++;
        }

        dialog_gui->background = GetBitmapGUI (dialog_gui->gui_system,
                                               dialog_gui->x, dialog_gui->y-12,
                                               dialog_gui->w, dialog_gui->h+12);

        PutBitZoneGUI (dialog, dialog_gui->x, dialog_gui->y-12);
        ShowGUI (dialog_gui->gui_system);
  }

  FreeBitmapGUI (dialog);
}
 
u_long RunDialogGUI (DialogGUI *dialog_gui) {

  DialogGUIItem        *dialog_item_lst = (DialogGUIItem *) \
                                           dialog_gui->dialog_item->dtos;
  DialogGUIItem        *dialog_item;
  u_long                xm, ym;
  u_long                mouse_flg       = 0;

  while (1) {
        ShowGUI (dialog_gui->gui_system);
        dialog_item = (dialog_item_lst + (dialog_gui->pos_dlg));

        if (!mouse_flg)
                dialog_item->access = DA_NORMAL;
        else
                mouse_flg = 0;

        if (DialogFuncs[dialog_item->type].run_func)
                DialogFuncs[dialog_item->type].run_func (dialog_item);

        switch (dialog_gui->way) {

                case DW_DOWN :  if (dialog_gui->pos_dlg < (dialog_gui->items-1))
                                        dialog_gui->pos_dlg++;
                                else
                                        dialog_gui->way = DW_UP;
                                break;
                case DW_UP :    if (dialog_gui->pos_dlg > 0)
                                        dialog_gui->pos_dlg--;
                                else
                                        dialog_gui->way = DW_DOWN;
                                break;
                case DW_TAB :   if (dialog_gui->pos_dlg < (dialog_gui->items-1))
                                        dialog_gui->pos_dlg++;
                                else
                                        dialog_gui->pos_dlg = 0;
                                break;
                case DW_STAY :  break;
                case DW_DONE :  return 1;
                case DW_ESC  :  return 0;
        }

        if (SKbHited() == KEY_ESC) return 0;

        if (mouse.event && M_LDOWN) {

                GUIGiveMousePos (dialog_gui->gui_system, &xm, &ym);
                if ((ym >= dialog_gui->y-12 && ym <= dialog_gui->y) && \
                    (xm >= dialog_gui->x && xm <= dialog_gui->xf)) {

                        if ((xm >= dialog_gui->xf-13) && (xm <= dialog_gui->xf-3)) {

                                DialogGUICloseDown (dialog_gui, dialog_gui->y-12);
                                while (M_LDOWN) ShowGUI (dialog_gui->gui_system);

                                GUIGiveMousePos (dialog_gui->gui_system, &xm, &ym);
                                if ((ym >= dialog_gui->y-12 && ym <= dialog_gui->y) && \
                                    (xm >= dialog_gui->xf-13 && xm <= dialog_gui->xf-3))
                                        return 0;
                                else
                                        DialogGUICloseUp (dialog_gui, dialog_gui->y-12);
                        } else
                                DialogGUIMoveWindow (dialog_gui);
                } else {
                        dialog_item = dialog_item_lst;

                        while (dialog_item->control) {
                                if (DialogFuncs[dialog_item->type].mouse_func)
                                        if (DialogFuncs[dialog_item->type].mouse_func(dialog_item)) {
                                                while (M_LDOWN)
                                                        ShowGUI (dialog_gui->gui_system);
                                                if (DialogFuncs[dialog_item->type].mouse_func(dialog_item)) {
                                                        dialog_item->access = DA_DIRECT;
                                                        mouse_flg = 1;
                                                } else
                                                        dialog_item->access = DA_NORMAL;
                                                break;
                                        }
                                dialog_item++;
                        }

                        while (M_LDOWN) ShowGUI (dialog_gui->gui_system);       
                }
        }
  }
}

TextDlg *CTextDlg (u_long x, u_long y, u_long col, char *text) {

  TextDlg      *text_dlg;

  text_dlg      = (TextDlg *) malloc (sizeof (TextDlg));

  text_dlg->x   = x;
  text_dlg->y   = y;
  text_dlg->col = col;

  strcpy (text_dlg->text, text);

  return (text_dlg);
}

void DTextDlg (DialogGUIItem *dialog_item) {

  TextDlg      *text_dlg        = (TextDlg *) dialog_item->dtos;
  DialogGUI    *dialog_gui      = dialog_item->dialog_gui;

  DrawTextGUIColor (dialog_item->dialog_gui->gui_system,
                    text_dlg->x + dialog_gui->x,
                    text_dlg->y + dialog_gui->y, text_dlg->col,
                    text_dlg->text);

}

SelDlg *CSelDlg (u_long x, u_long y, u_long w, u_long h,
                 u_long *var_sel, char *title) {

  SelDlg       *sel_dlg;

  sel_dlg       = (SelDlg *) malloc (sizeof (SelDlg));

  sel_dlg->x    = x;
  sel_dlg->y    = y;
  sel_dlg->w    = w;
  sel_dlg->h    = h;

  sel_dlg->items        = 0;
  sel_dlg->var_sel      = var_sel;

  strcpy (sel_dlg->title, title);

  sel_dlg->sel_item = OpenListObj (sizeof (SelItemDlg));

  return (sel_dlg);
}

void AddSelDlg (SelDlg *sel_dlg, u_long x, u_long y, char *text) {

  SelItemDlg    sel_item;

  sel_item.x    = x;
  sel_item.y    = y;
  sel_item.pos  = sel_dlg->items++;

  strcpy (sel_item.text, text);
  sel_item.control = 1;

  AddListObj (sel_dlg->sel_item, &sel_item);
}

void DSelDlg (DialogGUIItem *dialog_item) {

  GUISystem    *gui_system      = dialog_item->dialog_gui->gui_system;
  DialogGUI    *dialog_gui      = dialog_item->dialog_gui;
  SelDlg       *sel_dlg         = (SelDlg *)dialog_item->dtos;

  u_long        x               = sel_dlg->x + dialog_gui->x;
  u_long        y               = sel_dlg->y + dialog_gui->y;
  u_long        lon_title;

  DrawRevRectangleGUI (gui_system, x, y, x + sel_dlg->w,
                       y + sel_dlg->h, DIALOGCOLOR);

  lon_title = CntTextGUI (gui_system, sel_dlg->title);

  DrawPlainRectangleGUI (gui_system, x+3, y-2, x+lon_title+9, y+2,
                         DIALOGCOLOR);
  DrawTextGUIColor (gui_system, x+6, y-5, FONTHCOLOR, sel_dlg->title);
}

void FSelDlg (DialogGUIItem *dialog_item) {

  SelDlg       *sel_dlg         = (SelDlg *)dialog_item->dtos;

  FreeListObj (sel_dlg->sel_item);
}

ButtonDlg *CButtonDlg (u_long x, u_long y, u_long w, char *text,
                       u_long type, void (*func_call)()) {

  ButtonDlg    *button_dlg;

  button_dlg    = (ButtonDlg *)malloc (sizeof (ButtonDlg));

  button_dlg->x = x;
  button_dlg->y = y;
  button_dlg->w = w;

  strcpy (button_dlg->text, text);

  button_dlg->func_call = func_call;
  button_dlg->type      = type;

  return (button_dlg);
}

void DrawButtonOffDlg (DialogGUIItem *dialog_item, u_long state) {

  DialogGUI    *dialog_gui      = dialog_item->dialog_gui;
  GUISystem    *gui_system      = dialog_gui->gui_system;
  ButtonDlg    *button_dlg      = (ButtonDlg *)dialog_item->dtos;

  u_long        lon_text        = CntTextGUI (gui_system, button_dlg->text);
  u_long        x               = button_dlg->x + dialog_gui->x;
  u_long        y               = button_dlg->y + dialog_gui->y;
  u_long        med             = (button_dlg->w/2) - (lon_text/2);


  DrawRectangleGUI (gui_system, x, y-1, x+button_dlg->w, y+10,
                    DIALOGCOLOR);
  DrawTextGUIColor (gui_system, x+med, y, (state) ? FONTHCOLOR : FONTLCOLOR,
                    button_dlg->text);
}

void DrawButtonOnDlg (DialogGUIItem *dialog_item) {

  DialogGUI    *dialog_gui      = dialog_item->dialog_gui;
  GUISystem    *gui_system      = dialog_gui->gui_system;
  ButtonDlg    *button_dlg      = (ButtonDlg *)dialog_item->dtos;

  u_long        lon_text        = CntTextGUI (gui_system, button_dlg->text);
  u_long        x               = button_dlg->x + dialog_gui->x;
  u_long        y               = button_dlg->y + dialog_gui->y;
  u_long        med             = (button_dlg->w/2) - (lon_text/2);


  DrawRevRectangleGUI (gui_system, x, y-1, x+button_dlg->w, y+10,
                       DIALOGCOLOR);
  DrawTextGUIColor (gui_system, x+med+1, y, FONTLCOLOR, button_dlg->text);
}

void DButtonDlg (DialogGUIItem *dialog_item) {

  DrawButtonOffDlg (dialog_item, 0);
}

static void RunButtonDlg (DialogGUIItem *dialog_item) {

  DialogGUI    *dialog_gui      = dialog_item->dialog_gui;
  ButtonDlg    *button_dlg      = (ButtonDlg *)dialog_item->dtos;

  switch (button_dlg->type) {

        case DB_OK      : dialog_gui->way = DW_DONE;
                          break;
        case DB_CANCEL  : dialog_gui->way = DW_ESC;
                          break;
        case DB_FUNC    : if (button_dlg->func_call)
                                button_dlg->func_call(dialog_gui->parse_data);
                          dialog_gui->way = DW_STAY;
                          break;
        default         : dialog_gui->way = DW_STAY;
                          break;
  }
}

u_long RButtonDlg (DialogGUIItem *dialog_item) {

  DialogGUI    *dialog_gui      = dialog_item->dialog_gui;
  u_long        key;
  u_long        exit_flg        = 0;

  if (dialog_item->access == DA_DIRECT) {

        RunButtonDlg (dialog_item);
        DrawButtonOffDlg (dialog_item, 0);
        return 1;
  }

  DrawButtonOffDlg (dialog_item, 1);

  while (1) {
        ShowGUI (dialog_gui->gui_system);

        if (mouse.event && M_LDOWN) {
                dialog_gui->way = DW_STAY;
                break;
        }

        if ((key = SKbHited()) != 0) {
                switch (key) {
                        case KEY_LEFT :
                        case KEY_UP   : dialog_gui->way = DW_UP;
                                        exit_flg = 1;
                                        break;
                        case KEY_RIGHT:
                        case KEY_DOWN : dialog_gui->way = DW_DOWN;
                                        exit_flg = 1;
                                        break;
                        case KEY_TAB  : dialog_gui->way = DW_TAB;
                                        exit_flg = 1;
                                        break;
                        case KEY_ENTER: RunButtonDlg (dialog_item);
                                        exit_flg = 1;
                                        break;
                        case KEY_ESC:   dialog_gui->way = DW_ESC;
                                        exit_flg = 1;
                                        break;
                }

                if (exit_flg) break;
        }
  }

  DrawButtonOffDlg (dialog_item, 0);
  return 1;
}

u_long MButtonDlg (DialogGUIItem *dialog_item) {

  DialogGUI    *dialog_gui      = dialog_item->dialog_gui;
  ButtonDlg    *button_dlg      = (ButtonDlg *)dialog_item->dtos;

  u_long        x               = button_dlg->x + dialog_gui->x;
  u_long        y               = button_dlg->y + dialog_gui->y;
  u_long        xm, ym;

  GUIGiveMousePos (dialog_gui->gui_system, &xm, &ym);

  if ((xm < x) || (xm > (x+button_dlg->w))) return 0;
  if ((ym < (y-1)) || (ym > (y+10))) return 0;

  dialog_gui->pos_dlg = dialog_item->pos;

  DrawButtonOnDlg (dialog_item);

  return 1;
}

ListDlg *CListDlg (u_long x, u_long y, u_long w, u_long h, void *dtos,
                   u_long size_dtos) {

  ListDlg      *list_dlg;

  list_dlg      = (ListDlg *)malloc (sizeof (ListDlg));

  list_dlg->x           = x;
  list_dlg->y           = y;
  list_dlg->w           = w;
  list_dlg->h           = h;
  list_dlg->dtos        = dtos;
  list_dlg->m_line      = (h / 10);
  list_dlg->f_line      = 0;
  list_dlg->pos         = 0;
  list_dlg->size_dtos   = size_dtos;
  list_dlg->n_dtos      = 0;
  list_dlg->func_call   = NULL;
  list_dlg->d_click     = 0;
  list_dlg->scrl_bar    = NULL;

  list_dlg->list_item   = OpenListObj (sizeof (ItemListDlg));
  list_dlg->list_dtos   = OpenListObj (size_dtos);

  return (list_dlg);
}

void AddItemListDlg (ListDlg *list_dlg, char *msg, u_long type, u_long lon,
                     void *var) {

  ItemListDlg   item_list;

  item_list.control     = 1;
  item_list.type        = type;
  item_list.lon         = lon;
  item_list.var         = var;

  strcpy (item_list.msg, msg);

  AddListObj (list_dlg->list_item, &item_list);
}

void AddDtosListDlg (ListDlg *list_dlg, void *dtos) {

  list_dlg->n_dtos++;

  AddListObj (list_dlg->list_dtos, dtos);
}

void DListDlg (DialogGUIItem *dialog_item) {

  ListDlg      *list_dlg        = (ListDlg *)dialog_item->dtos;
  DialogGUI    *dialog_gui      = dialog_item->dialog_gui;
  GUISystem    *gui_system      = dialog_gui->gui_system;

  u_long        x               = (list_dlg->x + dialog_gui->x);
  u_long        y               = (list_dlg->y + dialog_gui->y);
  u_long        scrl_max;


  list_dlg->scrl_bar = MakeScrlBar (dialog_gui, list_dlg->x+list_dlg->w+1,
                                    list_dlg->y, list_dlg->h, 10);

  DrawRevRectangleGUI (gui_system, x, y, x+list_dlg->w, y+list_dlg->h,
                       DIALOGCOLOR);

  AListDlg (dialog_item);

  if (list_dlg->n_dtos < list_dlg->m_line)
        scrl_max = 0;
  else
        scrl_max = (list_dlg->n_dtos - list_dlg->m_line);

  ChScrlBar (list_dlg->scrl_bar, list_dlg->f_line, scrl_max);
  DrawScrlBar (list_dlg->scrl_bar);
}

static void CtrlListDlg (ListDlg *list_dlg) {

  if (list_dlg->pos < 0) list_dlg->pos = 0;

  if (list_dlg->pos > (list_dlg->n_dtos-1))
        list_dlg->pos = list_dlg->n_dtos-1;

  if (list_dlg->pos < list_dlg->f_line)
        list_dlg->f_line = list_dlg->pos;

  else if ((list_dlg->pos - list_dlg->f_line) > (list_dlg->m_line-1))
            list_dlg->f_line = (list_dlg->pos - (list_dlg->m_line-1));

} 

u_long RListDlg (DialogGUIItem *dialog_item) {

  DialogGUI    *dialog_gui      = dialog_item->dialog_gui;
  ListDlg      *list_dlg        = (ListDlg *)dialog_item->dtos;
  u_long        key;
  u_long        exit_flg        = 0;
  u_long        scrl_max;
  u_long        retn;


  if (!list_dlg->n_dtos) return 1;

  while (1) {

        ShowGUI (dialog_gui->gui_system);

        if (mouse.event && M_LDOWN) {
                dialog_gui->way = DW_STAY;
                break;
        }

        if (list_dlg->d_click) {

                key                     = KEY_ENTER;
                list_dlg->d_click       = 0;
        } else
                key = SKbHited();

        if (key) {

                switch (key) {
                        case KEY_LEFT :
                        case KEY_UP   : if (!list_dlg->pos) break;
                                        list_dlg->pos--;
                                        break;
                        case KEY_RIGHT:
                        case KEY_DOWN : if (list_dlg->pos == (list_dlg->n_dtos-1))
                                                break;
                                        list_dlg->pos++;
                                        break;
                        case KEY_PGDN : list_dlg->pos += (list_dlg->m_line-1);
                                        if (list_dlg->pos > (list_dlg->n_dtos-1))
                                                list_dlg->pos = (list_dlg->n_dtos-1);
                                        break;
                        case KEY_PGUP : list_dlg->pos -= (list_dlg->m_line-1);
                                        if (list_dlg->pos < 0)
                                                list_dlg->pos = 0;
                                        break;
                        case KEY_TAB  : dialog_gui->way = DW_TAB;
                                        exit_flg = 1;
                                        break;
                        case KEY_ENTER: if (list_dlg->func_call) {
                                                if (!list_dlg->func_call (dialog_item,
                                                                          &retn)) {
                                                        dialog_gui->way = retn;
                                                        exit_flg = 1;
                                                }
                                        }
                                        break;
                        case KEY_ESC  : dialog_gui->way = DW_ESC;
                                        exit_flg = 1;
                                        break;
                }

                CtrlListDlg (list_dlg);
                ChScrlBar (list_dlg->scrl_bar, list_dlg->f_line,
                           list_dlg->scrl_bar->max);
                AListDlg (dialog_item);

                if (exit_flg) break;
        }
  }

  return 1;
}

u_long MListDlg (DialogGUIItem *dialog_item) {

  DialogGUI    *dialog_gui      = (DialogGUI *) dialog_item->dialog_gui;
  ListDlg      *list_dlg        = (ListDlg *)   dialog_item->dtos;

  u_long        y               = (dialog_gui->y + list_dlg->y + 2);
  u_long        x               = (dialog_gui->x + list_dlg->x);
  u_long        my, mx;


  while (CheckScrlBar (list_dlg->scrl_bar)) {

        if (list_dlg->scrl_bar->pos < 0)
                list_dlg->f_line = 0;
        else
                list_dlg->f_line = list_dlg->scrl_bar->pos;

        if (list_dlg->f_line > (list_dlg->n_dtos - list_dlg->m_line))
                list_dlg->f_line = (list_dlg->n_dtos - list_dlg->m_line);

        AListDlg (dialog_item);
        ShowGUI (dialog_gui->gui_system);
  }

  GUIGiveMousePos (dialog_gui->gui_system, &mx, &my);

  if ((mx < x) || (mx > (x+list_dlg->w))) return 0;
  if ((my < y) || (my > (y+list_dlg->h-6))) return 0;

  while (M_LDOWN) {

        GUIGiveMousePos (dialog_gui->gui_system, &mx, &my);

        if ((mx < x) || (mx > (x+list_dlg->w))) return 0;
        if ((my < y) || (my > (y+list_dlg->h-6))) return 0;

        list_dlg->pos = (list_dlg->f_line + ((my - y) / 10));

        CtrlListDlg (list_dlg);
        AListDlg (dialog_item);
        ShowGUI (dialog_gui->gui_system);
  }

  if (mouse.left_presses > 1) {
        list_dlg->d_click               = 1;
        mouse.left_presses              = 0;
  }

  dialog_gui->pos_dlg = dialog_item->pos;
  
  return 1;
}

static void DrawLineListDlg (u_long x, u_long y, DialogGUIItem *dialog_item,
                             char *dtos_list, u_long state) {

  GUISystem    *gui_system      = dialog_item->dialog_gui->gui_system;
  ListDlg      *list_dlg        = (ListDlg *)dialog_item->dtos;
  ItemListDlg  *item_list       = (ItemListDlg *)list_dlg->list_item->dtos;

  char          tmp_str[120];

  DrawPlainRectangleGUI (gui_system, x-2, y, x+list_dlg->w-8, y+10,
                         (state) ? TDIALOGCOLOR : DIALOGCOLOR);

  memcpy (list_dlg->dtos, dtos_list, list_dlg->size_dtos);

  while (item_list->control) {

        FormatStrGUI (tmp_str, item_list->type, item_list->var,
                      item_list->lon);

        DrawTextGUIColor (gui_system, x, y+1, FONTHCOLOR, tmp_str);

        x += (item_list->lon*8);
        item_list++;
  }      
}

void AListDlg (DialogGUIItem *dialog_item) {

  ListDlg      *list_dlg        = (ListDlg *)dialog_item->dtos;
  DialogGUI    *dialog_gui      = dialog_item->dialog_gui;
  GUISystem    *gui_system      = dialog_gui->gui_system;
  char         *dtos_list       = (char *)list_dlg->list_dtos->dtos;

  u_long        x               = (list_dlg->x + dialog_gui->x + 5);
  u_long        y               = (list_dlg->y + dialog_gui->y + 2);
  u_long        lines_left      = list_dlg->m_line;
  u_long        pos             = list_dlg->f_line;

  if (!list_dlg->n_dtos) return;

  dtos_list += (list_dlg->f_line*list_dlg->size_dtos);

  while (lines_left--) {

        if (!*dtos_list) {
                DrawPlainRectangleGUI (gui_system, x-2, y,
                                       x+list_dlg->w-8, y+10, DIALOGCOLOR);
        } else {
                DrawLineListDlg (x, y, dialog_item, dtos_list,
                                 (pos==list_dlg->pos) ? 1 : 0);

                dtos_list += list_dlg->size_dtos;
        }
        pos++;
        y += 10;
  }

  dtos_list  = (char *)list_dlg->list_dtos->dtos;
  dtos_list += (list_dlg->pos*list_dlg->size_dtos);

  memcpy (list_dlg->dtos, dtos_list, list_dlg->size_dtos);

  DrawScrlBar (list_dlg->scrl_bar);
}

void FListDlg (DialogGUIItem *dialog_item) {

  ListDlg      *list_dlg        = (ListDlg *)dialog_item->dtos;

  FreeListObj (list_dlg->list_item);
  FreeListObj (list_dlg->list_dtos);

  if (list_dlg->scrl_bar) FreeScrlBar (list_dlg->scrl_bar);
}

void FillSelFileDlg (SelFileDlg *sel_file);
u_long EnterSelFileDlg (DialogGUIItem *dialog_item, u_long *retn);

SelFileDlg *CSelFileDlg (u_long x, u_long y, u_long w, u_long h,
                         char *path, char *wildcards) {

  SelFileDlg           *sel_file;

  sel_file      = (SelFileDlg *)malloc (sizeof (SelFileDlg));

  sel_file->list_dlg = CListDlg (x, y, w, h, &sel_file->file_info,
                                 sizeof (FileInfo));
  AddItemListDlg (sel_file->list_dlg, "Name", F_STRING, 12,
                  sel_file->file_info.name);

  strcpy (sel_file->wildcards, wildcards);
  strcpy (sel_file->path, path);
  strcpy (sel_file->first_path, sel_file->path);

  sel_file->list_dlg->func_call = EnterSelFileDlg;

  return (sel_file);
}

static u_long IsGoodFile (char *file, char *wildcard) {

  char         *p = (file + strlen (file));
  char         *w = (wildcard + strlen (wildcard));

  while (*w != '.') w--;

  while (*p != '.') {
        p--;
        if (p == file) return (!stricmp (w, "."));
  }

  return (!stricmp (p, w));
}

void FillSelFileDlg (SelFileDlg *sel_file) {

  int                   flag;
  DIR                  *cur_dir;
  DIR                  *read_dir;
  char                  wildcard[10][10];
  int                   n_wcard                 = 0;
  int                   cnt                     = 0;
  char                 *ptr                     = sel_file->wildcards;
  FileInfo             *file_info;
  FileInfo             *cur_file;
  FileInfo             *tmp_file;
  ListObj              *list_file;
  ListObj              *list_dir;
  unsigned              drive;
  unsigned              total_drives;
  unsigned              tmp_var;
  u_long                real_drives             = 1;
  u_long                n_items                 = 0;
  u_long                scrl_max;


  CeroListObj (sel_file->list_dlg->list_dtos);
  sel_file->list_dlg->n_dtos = 0;
  sel_file->list_dlg->pos = 0;

  list_file = OpenListObj (sizeof (FileInfo));
  list_dir  = OpenListObj (sizeof (FileInfo));

  while (1) {
        while (*ptr != ',') {
                wildcard[n_wcard][cnt++] = *ptr++;
                if (!*ptr) break;
        }
        wildcard[n_wcard][cnt] = 0;

        if (!*ptr) break;
        if (!*++ptr) break;

        cnt = 0;
        n_wcard++;
  }

  cur_dir = opendir (sel_file->path);

  while ((read_dir = readdir(cur_dir)) != NULL) {

        sel_file->file_info.control = 1;

        if (read_dir->d_attr & _A_SUBDIR) {
                strcpy (sel_file->file_info.name, read_dir->d_name);
                strcat (sel_file->file_info.name, "\\");
                sel_file->file_info.attr = read_dir->d_attr;
                AddListObj (list_file, &sel_file->file_info);

        } else {
                for (cnt = 0; cnt <= n_wcard; cnt++) {
                        if (IsGoodFile (read_dir->d_name, wildcard[cnt])) {
                                strcpy (sel_file->file_info.name,
                                        read_dir->d_name);
                                sel_file->file_info.attr = read_dir->d_attr;
                                AddListObj (list_file, &sel_file->file_info);
                                break;
                        }
                }
        }
  }

  file_info = (FileInfo *)list_file->dtos;

  if (list_file->cnt) {
    while (file_info->control) {

        tmp_file = (FileInfo *)list_file->dtos;
        cur_file = tmp_file;

        while (cur_file->control == 2) cur_file++;
        while (tmp_file->control) {
                if (tmp_file->control != 2) {
                        if (stricmp (cur_file->name, tmp_file->name) > 0)
                                cur_file = tmp_file;
                }
                tmp_file++;
        }

        cur_file->control = 2;

        strcpy (sel_file->file_info.name, cur_file->name);
        sel_file->file_info.attr = cur_file->attr;

        if (cur_file->attr & _A_SUBDIR)
                AddListObj (list_dir, &sel_file->file_info);
        else
                AddDtosListDlg (sel_file->list_dlg, &sel_file->file_info);

        file_info++;
    }
  }

  file_info = (FileInfo *)list_dir->dtos;

  if (list_dir->cnt) {

        while (file_info->control) {
                strcpy (sel_file->file_info.name, file_info->name);
                sel_file->file_info.attr = file_info->attr;
                if (stricmp (file_info->name, ".\\"))
                        AddDtosListDlg (sel_file->list_dlg,
                                        &sel_file->file_info);

                file_info++;
        }
  }

  closedir (cur_dir);

  _dos_getdrive (&drive);
  _dos_setdrive (drive, &total_drives);

  for (cnt = 0; cnt < total_drives; cnt++) {

        _dos_setdrive (real_drives, &tmp_var);
        _dos_getdrive (&tmp_var);

        if (tmp_var != real_drives) {
                if (real_drives) real_drives--;
                break;
        }

        real_drives++;
  }

  _dos_setdrive (drive, &tmp_var);

  for (cnt = 0; cnt < real_drives; cnt++) {

        sprintf (sel_file->file_info.name, "[-%c-]", 'A' + cnt);
        sel_file->file_info.attr = _A_DRIVE|(cnt<<8);
        AddDtosListDlg (sel_file->list_dlg, &sel_file->file_info);
  }

  FreeListObj (list_file);
  FreeListObj (list_dir);

  if (sel_file->list_dlg->n_dtos < sel_file->list_dlg->m_line)
        scrl_max = 0;
  else
        scrl_max = (sel_file->list_dlg->n_dtos - sel_file->list_dlg->m_line);

  ChScrlBar (sel_file->list_dlg->scrl_bar, 0, scrl_max);
}

u_long EnterSelFileDlg (DialogGUIItem *dialog_item, u_long *retn) {

  ListDlg      *list_dlg        = (ListDlg *)   dialog_item->dtos;
  SelFileDlg   *sel_file        = (SelFileDlg *)dialog_item->deriv_data;
  char         *p               = sel_file->path;
  char          new_path[80];
  DIR          *test_dir;
  unsigned      dummy;
  unsigned      drive;

  if (sel_file->file_info.attr & _A_SUBDIR) {

        if (!stricmp (sel_file->file_info.name, "..\\")) {

                p += (strlen (sel_file->path)-1);
                while (*p != '\\') p--;
                *p = 0;
                if (*(p-1) == ':') {
                        *p++ = '\\';
                        *p = 0;
                }

        } else {
                if (sel_file->path[strlen(sel_file->path)-1] != '\\')
                        strcat (sel_file->path, "\\");

                strcat (sel_file->path, sel_file->file_info.name);
                sel_file->path[strlen(sel_file->path)-1] = 0;
        }

        chdir (sel_file->path);

        FillSelFileDlg (sel_file);
        return 1;
  }

  if ((sel_file->file_info.attr&0xff) == _A_DRIVE) {

        _dos_getdrive (&drive);
        _dos_setdrive ((sel_file->file_info.attr>>8)+1, &dummy);

        strcpy (new_path, getcwd (NULL, 0));

        if ((test_dir = opendir (new_path)) == NULL) {
                _dos_setdrive (drive, &dummy);
                return 1;
        }

        strcpy (sel_file->path, new_path);
        _dos_setdrive (drive, &dummy);

        FillSelFileDlg (sel_file);

        return 1;
  }

  *retn = DW_DONE;

  return 0;
}

void DSelFileDlg (DialogGUIItem *dialog_item) {

  SelFileDlg   *sel_file        = (SelFileDlg *)dialog_item->dtos;

  dialog_item->deriv_data       = (SelFileDlg *)sel_file;
  dialog_item->dtos             = (ListDlg *)sel_file->list_dlg;

  DListDlg (dialog_item);
  FillSelFileDlg (sel_file);
  AListDlg (dialog_item);
}

u_long RSelFileDlg (DialogGUIItem *dialog_item) {

  return (RListDlg (dialog_item));
}

u_long MSelFileDlg (DialogGUIItem *dialog_item) {

  return (MListDlg (dialog_item));
}

void ASelFileDlg (DialogGUIItem *dialog_item) {

  AListDlg (dialog_item);
}

void FSelFileDlg (DialogGUIItem *dialog_item) {

  SelFileDlg   *sel_file        = (SelFileDlg *)dialog_item->deriv_data;

  chdir (sel_file->first_path);

  FListDlg (dialog_item);

  free (sel_file->list_dlg);
}

ScrlBar *MakeScrlBar (DialogGUI *dialog_gui, u_long x, u_long y, u_long h,
                      u_long paso) {

  ScrlBar              *scrl_bar;

  scrl_bar              = (ScrlBar *)malloc (sizeof (ScrlBar));

  scrl_bar->dialog_gui  = dialog_gui;
  scrl_bar->y           = y;
  scrl_bar->x           = x;
  scrl_bar->h           = h;
  scrl_bar->pos         = 0;
  scrl_bar->max         = 0;
  scrl_bar->paso        = paso;

  ChScrlBar (scrl_bar, 0, 0);

  return (scrl_bar);
}

void ChScrlBar (ScrlBar *scrl_bar, u_long pos, u_long max) {

  scrl_bar->pos         = pos;
  scrl_bar->max         = max;


  if (!scrl_bar->max)
        scrl_bar->hm = scrl_bar->h - 16;
  else {
        scrl_bar->hm = (((scrl_bar->h-16)*1.5) / (scrl_bar->max+1));

        if (scrl_bar->hm < 5) scrl_bar->hm = 5;
  }

  scrl_bar->pos_bar = ((scrl_bar->pos * (scrl_bar->h-16-(long)scrl_bar->hm)) / \
                      ((scrl_bar->max) ? scrl_bar->max : 1));
}

void DrawScrlBar (ScrlBar *scrl_bar) {

  DialogGUI    *dialog_gui      = scrl_bar->dialog_gui;
  GUISystem    *gui_system      = dialog_gui->gui_system;

  u_long        x               = (dialog_gui->x + scrl_bar->x);
  u_long        y               = (dialog_gui->y + scrl_bar->y);

  DrawPlainRectangleGUI (gui_system, x, y, x+10, y+scrl_bar->h, MENUCOLOR);
  DrawRectangleGUI (gui_system, x, y, x+10, y+8, DIALOGCOLOR);
  DrawRectangleGUI (gui_system, x, y+scrl_bar->h-8, x+10, y+scrl_bar->h,
                    DIALOGCOLOR);

  DrawRectangleGUI (gui_system, x, y+8+scrl_bar->pos_bar, x+10,
                    y+8+(long)scrl_bar->hm+scrl_bar->pos_bar,
                    DIALOGCOLOR);
}

u_long CheckScrlBar (ScrlBar *scrl_bar) {

  DialogGUI            *dialog_gui      = scrl_bar->dialog_gui;
  GUISystem            *gui_system      = dialog_gui->gui_system;

  u_long                x               = (dialog_gui->x + scrl_bar->x);
  u_long                y               = (dialog_gui->y + scrl_bar->y);
  u_long                mx, my;
  static u_long         have_bar        = 0;


  GUIGiveMousePos (gui_system, &mx, &my);

  if (!have_bar) {

        if ((mx < x) || (mx > (x+10))) return 0;
        if ((my < y) || (my > (y+scrl_bar->h))) return 0;
  }

  if (!M_LDOWN) {

        have_bar = 0;
        return 0;
  }

  if ((my > (y+scrl_bar->pos_bar+8)) && (my < (y+scrl_bar->pos_bar+8+(long)scrl_bar->hm)) || have_bar) {

        if (!have_bar) have_bar = (my - (y+8+scrl_bar->pos_bar));

        scrl_bar->pos_bar = (my - (y + 8) - have_bar);

        if (scrl_bar->pos_bar < 0) scrl_bar->pos_bar = 0;
        if ((scrl_bar->pos_bar+(long)scrl_bar->hm) > (scrl_bar->h-16))
                scrl_bar->pos_bar = (scrl_bar->h-16-(long)scrl_bar->hm);

        if (scrl_bar->h-16-(long)scrl_bar->hm)
                scrl_bar->pos = (scrl_bar->pos_bar * ((scrl_bar->max) ? \
                                                      scrl_bar->max : 1)) / \
                                (scrl_bar->h-16-(long)scrl_bar->hm);

        return 1;
  }

  have_bar = 0;
  return 0;
}

void FreeScrlBar (ScrlBar *scrl_bar) {

  free (scrl_bar);
}

FLAG MessageBox (GUISystem *gui_system, char *message, u_long buttons) {

  DialogGUI    *m_box;
  u_long        lon             = CntTextGUI (gui_system, message);

  m_box         = MakeDialogGUI (gui_system, "Message", lon+20);

  AddDialogGUI (m_box, D_TEXT, CTextDlg (5, 10, BLACKCOLOR, message));

  DrawDialogGUI (m_box, 0, 0);
  RunDialogGUI  (m_box);
  FreeDialogGUI (m_box);
}

void SetPalGUI (u_char *pal_ptr, u_long n_cols) {

  u_long        cnt;

  outp (0x3c8, 0);

  for (cnt = 0; cnt < n_cols; cnt++) {

        outp (0x3c9, *pal_ptr++);
        outp (0x3c9, *pal_ptr++);
        outp (0x3c9, *pal_ptr++);
  }
}

void LoadPCXBackgGUI (GUISystem *gui_system, char *file) {

  u_char       *dest            = gui_system->v_buffer + ((336*8) + 8);
  FILE         *file_st;
  u_char       *tmp_loc;
  u_char       *ptr;
  u_long        y_cnt;
  u_long        x_cnt;
  u_long        cnt;
  u_char       *pal_ptr;
                

  if ((file_st = fopen (file, "rb")) == NULL) return;

  if ((tmp_loc = (char *)malloc (65535)) == NULL) {
        fclose (file_st);
        return;
  }

  ptr = tmp_loc;

  while (!feof (file_st))
        *ptr++ = fgetc (file_st);

  ptr = (tmp_loc + 128);

  for (y_cnt = 0; y_cnt < 224; y_cnt++) {
        for (x_cnt = 0; x_cnt < 320; ) {
                if (*ptr <= 192) {
                        *dest++ = *ptr++;
                        x_cnt++;
                } else {
                        ptr++;
                        for (cnt = 0; cnt < (*(ptr-1) & 0x3f); cnt++) {
                                if (x_cnt == 320) {
                                        y_cnt++;
                                        x_cnt = 0;
                                        dest += (gui_system->w - 320);
                                }
                                *dest++ = *ptr;
                                x_cnt++;
                        }

                        ptr++;
                }
        }

        dest += (gui_system->w - 320);
  }

  ptr++;
  pal_ptr = ptr;

  for (cnt = 0; cnt < (256*3); cnt++) {
        *ptr = (*ptr >> 2);
        ptr++;
  }

  SetPalGUI (pal_ptr, 256);

  free (tmp_loc);
  fclose (file_st);
}

void PutPCXBackgGUI (GUISystem *gui_system, char *pcx_ptr) {

  u_char       *dest            = gui_system->v_buffer + ((gui_system->w*8) + 8);
  u_char       *tmp_loc         = pcx_ptr;
  u_char       *ptr;
  u_long        y_cnt;
  u_long        x_cnt;
  u_long        cnt;
  u_char       *pal_ptr;
                

  ptr = (tmp_loc + 128);

  for (y_cnt = 0; y_cnt < 224; y_cnt++) {
        for (x_cnt = 0; x_cnt < 320; ) {
                if (*ptr <= 192) {
                        *dest++ = *ptr++;
                        x_cnt++;
                } else {
                        ptr++;
                        for (cnt = 0; cnt < (*(ptr-1) & 0x3f); cnt++) {
                                if (x_cnt == 320) {
                                        y_cnt++;
                                        x_cnt = 0;
                                        dest += (gui_system->w - 320);
                                }
                                *dest++ = *ptr;
                                x_cnt++;
                        }

                        ptr++;
                }
        }

        dest += (gui_system->w - 320);
  }

  ptr++;
  pal_ptr = ptr;

  for (cnt = 0; cnt < (256*3); cnt++) {
        *ptr = (*ptr >> 2);
        ptr++;
  }

  SetPalGUI (pal_ptr, 256);

  ptr = pal_ptr;

  for (cnt = 0; cnt < (256*3); cnt++) {
        *ptr = (*ptr << 2);
        ptr++;
  }
}

void FormatStrGUI (char *dest, u_long type, void *var, u_long lon) {

  char          sp[120];

  switch (type) {

        case F_STRING :
                        sprintf (sp, "%%-%d.%ds", lon, lon);
                        sprintf (dest, sp, (char *)var);
                        break;
        case F_LONG :
                        sprintf (sp, "%%%dlu", lon);
                        sprintf (dest, sp, (*(long *)var));
                        break;
        case F_FLOAT :
                        sprintf (sp, "%%%d.2f", lon);
                        sprintf (dest, sp, (*(double *)var));
                        break;
  }
}

void WaitKey (void) {

  int           cnt     = 0;

  while (1) {
        if (keys[cnt++]) return;
        if (cnt == 255) cnt = 0;
  }
}

static u_long SKbHited (void) {

  int                   cnt;
  static u_long         last_key        = 0;
  static uclock_t       last_time       = 0;
  static u_long         first_time      = 0;


  if (last_key) {
        if (keys[last_key]) {
                if ((usec_clock(NULL) - last_time) > \
                    ((first_time) ? 300000 : 40000)) {
                        last_time = usec_clock(NULL);
                        first_time = 0;
                        return (last_key);
                }
                return (0);
        }
        last_key = 0;
  }

  for (cnt = 1; cnt < 255; cnt++) {
        if (keys[cnt]) {
                last_key = cnt;
                last_time = usec_clock (NULL);
                first_time = 1;
                return (cnt);
        }
  }

  last_key = 0;
  return (0);
}

u_long KbHited (void) {

  return (SKbHited());
}

static Bitmap *GetBitmapGUI (GUISystem *gui_system, u_long x, u_long y,
                             u_long w, u_long h) {

  Bitmap       *bitmap;
  char         *to_get          = gui_system->v_buffer;
  char         *to_put;
  int           cnt_y, cnt_x;


  bitmap = (Bitmap *)malloc (sizeof (Bitmap));
  bitmap->bit_zone = (char *) malloc (w*h);

  to_put        = bitmap->bit_zone;
  bitmap->w     = w;
  bitmap->h     = h;

  bitmap->gui_system = gui_system;

  to_get += (gui_system->w * y);
  to_get += x;

  for (cnt_y = 0; cnt_y < h; cnt_y++) {
        for (cnt_x = 0; cnt_x < w; cnt_x++)
                *to_put++ = *to_get++;

        to_get += (gui_system->w - w);
  }

  return (bitmap);
}

static void PutFreeBitZoneGUI (Bitmap *bitmap, u_long x, u_long y) {

  char         *draw_z          = bitmap->gui_system->v_buffer;
  char         *to_get          = bitmap->bit_zone;
  int           cnt_y, cnt_x;

  draw_z += (bitmap->gui_system->w * y);
  draw_z += x;

  for (cnt_y = 0; cnt_y < bitmap->h; cnt_y++) {
        for (cnt_x = 0; cnt_x < bitmap->w; cnt_x++)
                *draw_z++ = *to_get++;

        draw_z += (bitmap->gui_system->w - bitmap->w);
  }

  free (bitmap->bit_zone);
  free (bitmap);
}

static void PutBitZoneGUI (Bitmap *bitmap, u_long x, u_long y) {

  char         *draw_z          = bitmap->gui_system->v_buffer;
  char         *to_get          = bitmap->bit_zone;
  int           cnt_y, cnt_x;

  draw_z += (bitmap->gui_system->w * y);
  draw_z += x;

  for (cnt_y = 0; cnt_y < bitmap->h; cnt_y++) {
        for (cnt_x = 0; cnt_x < bitmap->w; cnt_x++)
                *draw_z++ = *to_get++;

        draw_z += (bitmap->gui_system->w - bitmap->w);
  }
}

static void FreeBitmapGUI (Bitmap *bitmap) {

  free (bitmap->bit_zone);
  free (bitmap);
}

ListObj *OpenListObj (int size_st) {

  ListObj      *list_obj;


  list_obj = (ListObj *) malloc (sizeof (ListObj));

  list_obj->cnt         = 0;
  list_obj->size_st     = size_st;
  list_obj->dtos        = NULL;

  return (list_obj);
}

void AddListObj (ListObj *list_obj, void *dtos) {

  void         *list_tmp;
  u_long       *tmp;
  u_char       *ptr;

  if (!list_obj->cnt) {

        list_obj->dtos  = (char *) malloc (2 * list_obj->size_st);
        list_obj->cnt   = 2;

        tmp             = (u_long *) list_obj->dtos;
        *tmp            = 0;
  }

  list_tmp      = list_obj->dtos;
  ptr           = (u_char *) list_tmp;

  ptr += (list_obj->size_st * (list_obj->cnt - 2));

  memcpy (ptr, dtos, list_obj->size_st);
  ptr += list_obj->size_st;

  tmp  = (u_long *) ptr;
  *tmp = 0;

  list_obj->cnt++;

  list_obj->dtos        = (char *) realloc (list_obj->dtos,
                                            list_obj->cnt * list_obj->size_st);
}

void DelListObj (ListObj *list_obj, u_char *item) {

  u_char       *copy_tmp;
  u_long       *tmp;

  while (1) {

        copy_tmp           = item;

        copy_tmp += list_obj->size_st;
        memcpy (item, copy_tmp, list_obj->size_st);

        tmp                = (u_long *) item;
        if (!*tmp) break;

        item += list_obj->size_st;
  }

  list_obj->cnt--;

  if (list_obj->cnt == 2) {
        list_obj->cnt  = 0;
        free (list_obj->dtos);
        list_obj->dtos = NULL;

        return;
  }

  list_obj->dtos        = (char *) realloc (list_obj->dtos,
                                            list_obj->cnt * list_obj->size_st);

}

void CeroListObj (ListObj *list_obj) {

  if (list_obj->dtos) {
        free (list_obj->dtos);
        list_obj->dtos = NULL;
  }

  list_obj->cnt = 0;
}

void FreeListObj (ListObj *list_obj) {

  if (list_obj->dtos) free (list_obj->dtos);
  free (list_obj);
}

int LockRegion (void *address, unsigned length) {

  union REGS regs;
  unsigned linear;

  linear        = (unsigned) address;

  regs.w.ax     = 0x600;
  regs.w.bx     = (linear >> 16);
  regs.w.cx     = (linear & 0xFFFF);
  regs.w.si     = (length >> 16);
  regs.w.di     = (length & 0xFFFF);

  int386 (0x31, &regs, &regs);
  return (! regs.w.cflag);
}

long GetClock(void);
#pragma aux GetClock = \
"cli"\
"mov ebx,46ch"\
"mov eax,[ebx]"\
value [eax];

void _loadds far MouseHandler (int max, int mbx, int mcx, int mdx, int msi, int mdi) {
#pragma aux MouseHandler parm [EAX] [EBX] [ECX] [EDX] [ESI] [EDI]

  if (M_LDOWN) mouse.left_was_pressed = 1;

  mouse.event           = (unsigned short) max;
  mouse.buttonstatus    = (unsigned short) mbx;
  mouse.x               = (unsigned short) mcx;
  mouse.y               = (unsigned short) mdx;

  if (!M_LDOWN && mouse.left_was_pressed) {

        mouse.check_time = GetClock();

        if (!mouse.left_presses) {
                mouse.left_presses++;

        } else {
                if ((mouse.check_time - mouse.last_l_press) < 15)
                        mouse.left_presses++;
                else
                        mouse.left_presses = 0;
        }

        mouse.last_l_press = mouse.check_time;
  }

  mouse.left_was_pressed = 0;
}

void cbc_end (void) {}

void Pushad(void);
#pragma aux Pushad = \
"pushad";

void Popad(void);
#pragma aux Popad = \
"popad";


void GUIMouseOn (void) {

  union REGS rin;

  rin.w.ax = 1;
  int386 (0x33, &rin, &rin);
}

void GUIMouseOff (void) {

  union REGS rin;

  rin.w.ax = 2;
  int386 (0x33, &rin, &rin);
}

void GUIMouseMax (u_long min_h, u_long max_h, u_long min_v, u_long max_v) {

  union REGS regs;

  regs.w.ax = 0x7;
  regs.w.cx = min_h;
  regs.w.dx = max_h;

  int386 (0x33, &regs, &regs);

  regs.w.ax = 0x8;
  regs.w.cx = min_v;
  regs.w.dx = max_v;

  int386 (0x33, &regs, &regs);
}

int GUIMouseReset (void) {

  union REGS rin, rout;

  rin.w.ax = 0;
  int386 (0x33, &rin, &rout);

  return (rout.w.ax ? rout.w.bx : rout.w.ax);
}

void GUIMouseSetPos (u_long x, u_long y) {

  union REGS rin;

  rin.w.cx = x;
  rin.w.dx = y;
  rin.w.ax = 4;
  int386 (0x33, &rin, &rin);
}

void GUIMouseInit (void) {

  struct SREGS sregs;
  union REGS rin, rout;
  int (far *function_ptr) ();

  segread (&sregs);

  rin.w.ax = 0;
  int386 (0x33, &rin, &rout);
  if (rout.w.ax != -1) {
        mouse_present = 0;
        return;
  }

  mouse_present = 1;
  if ((! LockRegion (&mouse, sizeof (struct _mouse_))) ||
        (! LockRegion ((void near *) MouseHandler,
                (char *) cbc_end - (char near *) MouseHandler))) exit (1);

  rin.w.ax      = 0xC;
  rin.w.cx      = 0x1f;
  function_ptr  = MouseHandler;
  rin.x.edx     = FP_OFF (function_ptr);
  sregs.es      = FP_SEG (function_ptr);

  int386x (0x33, &rin, &rout, &sregs);

  memset (mouse, 0, sizeof (struct _mouse_));
}

static void GUIGiveMousePos (GUISystem *gui_system, u_long *x, u_long *y) {

  *x = mouse.x;
  *y = mouse.y;

  //*x = ((mouse.x * gui_system->vga_w) / 640) + ((gui_system->w - gui_system->vga_w)/2);
  //*y = ((mouse.y * gui_system->vga_h) / 200) + ((gui_system->h - gui_system->vga_h)/2);
}
