
#include <stdio.h>
#include <malloc.h>
#include <mem.h>
#include <dos.h>

#include "m68k.h"
#include "m68ktbl.h"
#include "st0rm.h"
#include "m68misc.h"
#include "misc.h"
#include "vdp.h"


u_long profile_op[65535];

int movem_index1[256];
int movem_index2[256];
int movem_next[256];
UBYTE *actadr;

unsigned char *RAM;

ULONG   ExtOpCode;

regstruct regs, lastint_regs;

void   *regs_ptr        = &regs;

union flagu intel_flag_lookup[256];
//union flagu regflags;

void   *flags_ptr       = &regs.regflags;

#define MC68000_interrupt() (cpu_interrupt())


static int icount=0;
static int MC68000_IPeriod=0;

static int InitStatus=0;



static void initCPU(void)
{
    int i,j;

    for (i = 0 ; i < 256 ; i++) {
      for (j = 0 ; j < 8 ; j++) {
       if (i & (1 << j)) break;
      }
     movem_index1[i] = j;
     movem_index2[i] = 7-j;
     movem_next[i] = i & (~(1 << j));
    }
    for (i = 0; i < 256; i++) {
         intel_flag_lookup[i].flags.c = !!(i & 1);
         intel_flag_lookup[i].flags.z = !!(i & 64);
         intel_flag_lookup[i].flags.n = !!(i & 128);
         intel_flag_lookup[i].flags.v = 0;
    }

}

void Exception(int nr, CPTR oldpc)
{
   MakeSR();

   if(!regs.s) {
      regs.a[7]=regs.isp;
      regs.s=1;
   }

   if (nr != 28 && nr != 30)
        PrintELog ("[68K] Exception %x at %lx", nr, regs.pc);

   regs.a[7] -= 4;
   put_long (regs.a[7], m68k_getpc ());
   regs.a[7] -= 2;
   put_word (regs.a[7], regs.sr);
   m68k_setpc(get_long(regs.vbr + 4*nr));

   regs.t1 = regs.t0 = regs.m = 0;
}

void Interrupt68k(int level)
{
   int ipl=(regs.sr&0xf00)>>8;
   if(level>=ipl)
        Exception(24+level,0);
   else
        m68k_intr_run = 0;
}

void Init68k() {

   int i;

   BuildCPU ();
   initCPU();

   for (i = 0; i < 65535; i++)
        profile_op[i] = 0;
}

void Init68000(long IPeriod)
{
if (!InitStatus)
{
        Init68k();
	InitStatus=1;
}

  MC68000_IPeriod = IPeriod;
  icount = IPeriod;

   regs.a[7]=get_long(0);
   m68k_setpc(get_long(4));

   regs.s = 1;
   regs.m = 0;
   regs.stopped = 0;
   regs.t1 = 0;
   regs.t0 = 0;
   ZFLG = CFLG = NFLG = VFLG = 0;
   regs.intmask = 7;
   regs.vbr = regs.sfc = regs.dfc = 0;
   regs.fpcr = regs.fpsr = regs.fpiar = 0;
}


void MC68000_Execute(void)
{
        UWORD opcode;

       /* do
        {*/
		opcode=nextiword();

                //icount -= 15;
                ExtOpCode = (ULONG)opcode;
                cpufunctbl[opcode]();

        /*}
	while (icount>0);
	icount += MC68000_IPeriod;
        Interrupt68k(MC68000_interrupt());*/
}

int RunCPU (void) {

  Execute_CPU ();

/*ExtOpCode = (ULONG)nextiword ();
  cpufunctbl[ExtOpCode]();
  profile_op[ExtOpCode]++;*/

  return 1;
}

void ExecutenB_CPU (unsigned long cnt) {

  while (cnt--) {
        ExtOpCode = (ULONG)nextiword ();
        cpufunctbl[ExtOpCode]();
        profile_op[ExtOpCode]++;
  }
}

UBYTE *allocmem(long size, UBYTE init_value) {
   UBYTE *p;
   p=(UBYTE *)malloc(size);
   if (!p) {
      printf("No enough memory !\n");
   }
   return(p);
}


void abort (void) {

  printf ("\naborting...\n");
  return;
  exit (255);
}

void cpu_interrupt () {

  return;
}

void MakeFSRA (void) {

    NFLG = (regs.sr >> 3) & 1;
    ZFLG = (regs.sr >> 2) & 1;
    VFLG = (regs.sr >> 1) & 1;
    CFLG = regs.sr & 1;
}

UWORD nextiwordA (void) {

  regs.pc &= 0xffffff;
  regs.pc+=2;
  return (LoadWMem(regs.pc-2));
}
