/*************************************************************************

                          st0rm SGE Source Code

                          (c)1998 David Sanchez
                           st0rm@melodysoft.com

                        Released on 17th March 1999
        

Este codigo fuente lo puedes utilizar para:

- Usarlo como fuente de informacin para tus proyectos.
- Continuar el proyecto st0rm.
- Empezar un emulador desde 0 teniendo este como base.

Lo nico que pido si te es util y lo usas, es que lo menciones en tu
proyecto.

Tendras que perdonarme la falta de comentarios y el desorden total,
aun asi puede ser util.


COMENTARIOS EN README.TXT

*************************************************************************/


#include <dos.h>
#include <stdio.h>
#include <malloc.h>
#include <conio.h>
#include <time.h>
#include <mem.h>
#include "vga.h"
#include "misc.h"
#include "header.h"
#include "st0rm.h"
#include "m68misc.h"
#include "m68k.h"
#include "vdp.h"
#include "genio.h"
#include "m68deb.h"



void ErrorMem (u_long pos);


u_char                  m68k_intr_run    = 0;

extern u_char           vdp_write;


void PrintRegs (void) {

  int           y;

  for (y = 0; y < 8; y++)
        PrintTxt (y+2, 10, "d%d = %08lX      a%d = %08lX", y,
                  regs.d[y], y, regs.a[y]);

  PrintTxt (12, 10, "PC = %08lX", regs.pc);
  PrintTxt (13, 10, "SR = %04lX", regs.sr);
  PrintTxt (15, 10, "NI = %04lX %-20.20s", GivePcOp(), GiveCodeName ());

}

void PrintRegsStdio (void) {

  int           y;


  printf ("\n");

  for (y = 0; y < 8; y++) {
        printf ("d%d = %08lX  ", y, regs.d[y]);
        if ((y & 3)==3) printf ("\n");
  }

  for (y = 0; y < 8; y++) {
        printf ("a%d = %08lX  ", y, regs.a[y]);
        if ((y & 3)==3) printf ("\n");
  }

  printf ("\nPC  = %08lX", regs.pc);
  printf ("\nSR  = %04lX", regs.sr);
  printf ("\nNI  = %04lX %-20.20s\n\n", GivePcOp(), GiveCodeName ());

  for (y = 0; y < 24; y++) {
        printf ("vdp%02d = %02lX  ", y, vdp.reg[y]);
        if (!((y+1)%6)) printf ("\n");
  }

  printf ("\n");
}

void DumpMem (void) {

  FILE         *tmp_file;

  tmp_file = fopen ("Z80RAM.MEM", "wb");
  fwrite ((char *) mem.ram.z80_ram, 0x2000, 1, tmp_file);
  fclose (tmp_file);

  tmp_file = fopen ("RAM.MEM", "wb");
  fwrite ((char *) mem.ram.ram_space, 0x10000, 1, tmp_file);
  fclose (tmp_file);

  tmp_file = fopen ("VRAM.MEM", "wb");
  fwrite ((char *) mem.ram.vram, 0x10000, 1, tmp_file);
  fclose (tmp_file);

  tmp_file = fopen ("CRAM.MEM", "wb");
  fwrite ((char *) mem.ram.cram, 0x80, 1, tmp_file);
  fclose (tmp_file);

  tmp_file = fopen ("VSRAM.MEM", "wb");
  fwrite ((char *) mem.ram.vsram, 0x80, 1, tmp_file);
  fclose (tmp_file);
}

u_short *GivePcAddr (void) {

  char         *res;

  res = mem.rom_space + (long)regs.pc;

  return ((u_short *)res);
}

u_short GivePcOp (void) {

  u_short      *op      = (u_short *)(mem.rom_space + (u_long)regs.pc);

  return ((u_short)RorShort (*op));
}

long LoadLMem (u_long pos) {

  char         *tmp;

  pos &= 0xffffff;

  if (pos <= 0x3fffff) {

        tmp = mem.rom_space + (long)pos;
        return (RorLong ((*(u_long *)tmp)));
  }

  if (pos <= 0x9fffff) ErrorMem (pos);

  if (pos >= 0xa00000 && pos <= 0xa01fff) {

        tmp = mem.ram.z80_ram + (long)(pos - 0xa00000);
        return (RorLong ((*(u_long *)tmp)));
  }

  if (pos >= 0xa04000 && pos <= 0xa14fff) {

        return ((long)ReadIOPort (pos, 2));
  }

  if (pos >= 0xc00000 && pos <= 0xc00fff) {

        return ((long)ReadVDPPort (pos, 2));
  }

  if (pos >= 0xff0000 && pos <= 0xffffff) {

        tmp = mem.ram.ram_space + (long)(pos - 0xff0000);
        return (RorLong ((*(u_long *)tmp)));
  }

  if (pos >= 0xfe0000 && pos <= 0xfeffff) {

        tmp = mem.ram.ram_space + (long)(pos - 0xfe0000);
        return (RorLong ((*(u_long *)tmp)));
  }

  ErrorMem (pos);
  return 0;
}

short LoadWMem (u_long pos) {

  char         *tmp;

  pos &= 0xffffff;

  if (pos <= 0x3fffff) {

        tmp = mem.rom_space + (long)pos;
        return (RorShort ((*(u_short *)tmp)));
  }

  if (pos <= 0x9fffff) ErrorMem (pos);

  if (pos >= 0xa00000 && pos <= 0xa01fff) {

        tmp = mem.ram.z80_ram + (long)(pos - 0xa00000);
        return (RorShort ((*(u_short *)tmp)));
  }

  if (pos >= 0xa04000 && pos <= 0xa14fff) {

        return ((short)ReadIOPort (pos, 1));      
  }

  if (pos >= 0xc00000 && pos <= 0xc0ffff) {

        return ((short)ReadVDPPort (pos, 1));
  }

  if (pos >= 0xff0000 && pos <= 0xffffff) {

        tmp = mem.ram.ram_space + (long)(pos - 0xff0000);
        return (RorShort ((*(u_short *)tmp)));
  }

  if (pos >= 0xfe0000 && pos <= 0xfeffff) {

        tmp = mem.ram.ram_space + (long)(pos - 0xfe0000);
        return (RorShort ((*(u_short *)tmp)));
  }

  ErrorMem (pos);
  return 0;
}

char LoadBMem (u_long pos) {

  char         *tmp;

  pos &= 0xffffff;

  if (pos <= 0x3fffff) {

        tmp = mem.rom_space + (long)pos;
        return (*tmp);
  }

  if (pos <= 0x9fffff) ErrorMem (pos);

  if (pos >= 0xa00000 && pos <= 0xa01fff) {

        tmp = mem.ram.z80_ram + (long)(pos - 0xa00000);
        return (*tmp);
  }

  if (pos >= 0xa04000 && pos <= 0xa14fff) {

        return ((char)ReadIOPort (pos, 0));
  }

  if (pos >= 0xc00000 && pos <= 0xc0ffff) {

        return ((char)ReadVDPPort (pos, 0));
  }

  if (pos >= 0xff0000 && pos <= 0xffffff) {

        tmp = mem.ram.ram_space + (long)(pos - 0xff0000);
        return (*tmp);
  }

  if (pos >= 0xfe0000 && pos <= 0xfeffff) {

        tmp = mem.ram.ram_space + (long)(pos - 0xfe0000);
        return (*tmp);
  }

  ErrorMem (pos);
  return 0;
}

long LoadMem (u_long pos, u_short size) {

  pos &= 0xffffff;

  switch (size) {

        case 0 : return ((long)LoadBMem (pos) & 0xff);
                 break;
        case 1 : return ((long)LoadWMem (pos) & 0xffff);
                 break;
        case 2 :
        default: return ((long)LoadLMem (pos));
                 break;
  }
}

void SaveLMem (u_long pos, long to_save) {

  char         *tmp;

  pos &= 0xffffff;

  if (pos <= 0x3fffff) {

        tmp = mem.rom_space + (long)pos;
        (*(long *)tmp) = RorLong (to_save);
        return;
  }

  if (pos <= 0x9fffff) ErrorMem (pos);

  if (pos >= 0xa00000 && pos <= 0xa01fff) {

        tmp = mem.ram.z80_ram + (long)(pos - 0xa00000);
        (*(long *)tmp) = RorLong (to_save);
        return;
  }

  if (pos >= 0xa04000 && pos <= 0xa14fff) {

        WriteIOPort (pos, 2, to_save);
        return;
  }

  if (pos >= 0xc00000 && pos <= 0xc0ffff) {

        WriteVDPPort (pos, 2, to_save);
        return;
  }

  //vdp_write = 1;

  if (pos >= 0xff0000 && pos <= 0xffffff) {

        tmp = mem.ram.ram_space + (long)(pos - 0xff0000);
        (*(long *)tmp) = RorLong (to_save);
        return;
  }

  if (pos >= 0xfe0000 && pos <= 0xfeffff) {

        tmp = mem.ram.ram_space + (long)(pos - 0xfe0000);
        (*(long *)tmp) = RorLong (to_save);
        return;
  }

  ErrorMem (pos);
}

void SaveWMem (u_long pos, short to_save) {

  char         *tmp;

  pos &= 0xffffff;

  if (pos <= 0x3fffff) {

        tmp = mem.rom_space + (long)pos;
        (*(short *)tmp) = RorShort (to_save);
        return;
  }

  if (pos <= 0x9fffff) ErrorMem (pos);

  if (pos >= 0xa00000 && pos <= 0xa01fff) {

        tmp = mem.ram.z80_ram + (long)(pos - 0xa00000);
        (*(short *)tmp) = RorShort (to_save);
        return;
  }

  if (pos >= 0xa04000 && pos <= 0xa14fff) {

        WriteIOPort (pos, 1, to_save);
        return;
  }

  if (pos >= 0xc00000 && pos <= 0xc0ffff) {

        WriteVDPPort (pos, 1, to_save);
        return;
  }

  //vdp_write = 1;

  if (pos >= 0xff0000 && pos <= 0xffffff) {

        tmp = mem.ram.ram_space + (long)(pos - 0xff0000);
        (*(short *)tmp) = RorShort (to_save);
        return;
  }

  /*if (pos >= 0xfe0000 && pos <= 0xfeffff) {

        tmp = mem.ram.ram_space + (long)(pos - 0xfe0000);
        (*(short *)tmp) = RorShort (to_save);
        return;
  }*/


  ErrorMem (pos);
}

void SaveBMem (u_long pos, char to_save) {

  char         *tmp;

  pos &= 0xffffff;

  if (pos <= 0x3fffff) {

        tmp = mem.rom_space + (long)pos;
        *tmp = to_save;
        return;
  }

  if (pos <= 0x9fffff) ErrorMem (pos);

  if (pos >= 0xa00000 && pos <= 0xa01fff) {

        tmp = mem.ram.z80_ram + (long)(pos - 0xa00000);
        *tmp = to_save;
        return;
  }

  if (pos >= 0xa04000 && pos <= 0xa14fff) {

        WriteIOPort (pos, 0, to_save);
        return;
  }

  if (pos >= 0xc00000 && pos <= 0xc0ffff) {

        WriteVDPPort (pos, 0, to_save);
        return;
  }

  //vdp_write = 1;

  if (pos >= 0xff0000 && pos <= 0xffffff) {

        tmp = mem.ram.ram_space + (long)(pos - 0xff0000);
        *tmp = to_save;
        return;
  }

  if (pos >= 0xfe0000 && pos <= 0xfeffff) {

        tmp = mem.ram.ram_space + (long)(pos - 0xfe0000);
        *tmp = to_save;
        return;
  }

  ErrorMem (pos);
}

void SaveMem (u_long pos, u_short size, long to_save) {

  pos &= 0xffffff;

  switch (size) {

        case 0  : SaveBMem (pos, (char)to_save);
                  break;
        case 1  : SaveWMem (pos, (short)to_save);
                  break;
        case 2  :
        default : SaveLMem (pos, (long)to_save);
                  break;
  }
}

void ErrorMem (u_long pos) {

  PrintELog ("[68K] Invalid Address: %lx, PC = %lx = %x %s", pos, regs.pc-2,
              ExtOpCode, GiveOpCodeName (ExtOpCode));
  ExitNow ();
}

long LoadFromReg (u_long reg, u_short size) {

  switch (size) {

        case 0  : return (reg & 0xff);
                  break;
        case 1  : return (reg & 0xffff);
                  break;
        case 2  :
        default : return (reg);
                  break;
  }
}

void SaveToReg (u_long *reg, u_short size, long res) {

  switch (size) {

        case 0  :
                  *reg &= 0xffffff00;
                  *reg |= (res & 0xff);
                  break;
        case 1  :
                  *reg &= 0xffff0000;
                  *reg |= (res & 0xffff);
                  break;
        case 2  :
        default :
                  *reg = res;
                  break;
  }
}

long GiveRealType (long src, u_short size) {

  signed char           c_src;
  signed short          s_src;
  long                  dest;

  switch (size) {

        case 0 : c_src = (signed char) src;
                 if (c_src < 0)
                        dest = (signed char)(src);
                 else
                        dest = src;
                 return (dest);
                 break;

        case 1 : s_src = (signed short) src;
                 if (s_src < 0)
                        dest = (signed short)(src);
                 else
                        dest = src;
                 return (dest);
                 break;

        case 2 : return (src);
                 break;
  }

  return (src);
}
                        
void Call68kIntr (u_long addr) {

  m68k_intr_run = 1;

  MakeSR ();

  if (!regs.s) {
        regs.a[7] = regs.isp;
        regs.s = 1;
  }

  regs.a[7] -= 4;
  put_long (regs.a[7], m68k_getpc ());
  regs.a[7] -= 2;
  put_word (regs.a[7], regs.sr);

  m68k_setpc (addr);

  regs.t1 = regs.t0 = regs.m = 0;
}

void M68kIntrRet (u_long addr) {

  Call68kIntr (addr);

  while (m68k_intr_run) {
        RunCPU ();
        RunVDPIntr ();
  }
}

void M68kExecuteN (u_long inst) {

  while (inst--) RunCPU ();
}

