/*************************************************************************

                          st0rm SGE Source Code

                          (c)1998 David Sanchez
                           st0rm@melodysoft.com

                        Released on 17th March 1999
        

Este codigo fuente lo puedes utilizar para:

- Usarlo como fuente de informacin para tus proyectos.
- Continuar el proyecto st0rm.
- Empezar un emulador desde 0 teniendo este como base.

Lo nico que pido si te es util y lo usas, es que lo menciones en tu
proyecto.

Tendras que perdonarme la falta de comentarios y el desorden total,
aun asi puede ser util.


COMENTARIOS EN README.TXT

*************************************************************************/


#include <dos.h>
#include <stdio.h>
#include <malloc.h>
#include <conio.h>
#include <time.h>
#include <mem.h>
#include <i86.h>
#include <stdarg.h>
#include "vga.h"
#include "header.h"
#include "st0rm.h"
#include "m68k.h"
#include "m68misc.h"
#include "misc.h"


unsigned long    base_video;
volatile u_long _time_taken             = 0;


volatile char   keys[128];
volatile char   ekeys[128];


void   (interrupt far *OldKbIntr)(void);
void   (interrupt far *OldTimeIntr)(void);
void    interrupt far KbIntr(void);
void    interrupt far TimeIntr(void);



void _loadds interrupt far KbIntr (void) {
#pragma aux KbIntr modify [EAX EBX ECX EDX ESI EDI]

  static        extkey;
  char          scan_code       = inp (0x60);
  char          retr;


  scan_code = inp (0x60);

  if (scan_code == 0xe0)
        extkey = 1;
  else {
        if (scan_code & 0x80)
                (extkey ? keys : keys)[scan_code & 0x7f] = 0;
        else
                (extkey ? keys : keys)[scan_code] = 1;

        extkey = 0;
  }

  outp (0x20, 0x20);
}

void _loadds interrupt far TimeIntr (void) {
#pragma aux TimeIntr modify [EAX EBX ECX EDX ESI EDI]

  _time_taken++;

  outp (0x20, 0x20);
}

void InitTimer (void) {

  u_long        freq    = 100;                  // 100hz
  u_long        cmp     = 1193180L/freq;

  _time_taken = 0;

  OldTimeIntr = getvect(0x08);

  outp (0x43, 0x36);
  outp (0x40, cmp&0xff);
  outp (0x40, (cmp>>8)&0xff);

  setvect (0x08, TimeIntr);
}

void ReleaseTimer (void) {

  setvect (0x08, OldTimeIntr);

  outp (0x43, 0x36);
  outp (0x40, 0);
  outp (0x40, 0);
}

void ReverseString (char *buf) {

  char          tmp[100];
  char         *p, *s;
  int           cnt;

  p   = buf;
  s   = tmp;
  p  += strlen (buf) - 1;
  cnt = strlen (buf);

  while (cnt--) *s++ = *p--;

  *s = 0;

  strcpy (buf, tmp);
}

void IniciaTxtVideo (void) {

  union REGS rin, rout;

  int386 (0x11, &rin, &rout);

  if ((rout.w.ax & 0x30) == 0x30)
        base_video = 0xB000 << 4;
  else
        base_video = 0xB800 << 4;

}

char *PosTxtPtr (int y, int x) {

  int despla;
  char *p;

  despla = ((y*160) + (x*2)) - 162;

  p = (char *) base_video;
  p += despla;

  return (p);
}

void PrintTxt (int y, int x, char *txt, ...) {

  va_list       arg;
  char          msg[81];
  char         *p;
  char         *s               = msg;

  va_start (arg, txt);
  vsprintf (msg, txt, arg);
  va_end (arg);

  p = PosTxtPtr (y, x);

  while (*s) {
        *p++ = *s++;
        p++;
  }
}

void ClearTxt (void) {

  char         *p       = PosTxtPtr (1, 1);
  int           cnt     = 2000;

  while (cnt--) {
        *p++ = 0;
        p++;
  }
}

void PrintLog (char *txt, ...) {

  va_list       arg;
  char          msg[162];


  if (!log_flg) return;

  va_start (arg, txt);
  vsprintf (msg, txt, arg);
  va_end (arg);

  fprintf (log_file, "%s\r\n", msg);
  fflush (log_file);
}

void PrintELog (char *txt, ...) {

  va_list       arg;
  char          msg[162];


  if (!log_flg && !loge_flg) return;

  va_start (arg, txt);
  vsprintf (msg, txt, arg);
  va_end (arg);

  fprintf (log_file, "%s\r\n", msg);
  fflush (log_file);
}
  
