/*************************************************************************

                          st0rm SGE Source Code

                          (c)1998 David Sanchez
                           st0rm@melodysoft.com

                        Released on 17th March 1999
        

Este codigo fuente lo puedes utilizar para:

- Usarlo como fuente de informacin para tus proyectos.
- Continuar el proyecto st0rm.
- Empezar un emulador desde 0 teniendo este como base.

Lo nico que pido si te es util y lo usas, es que lo menciones en tu
proyecto.

Tendras que perdonarme la falta de comentarios y el desorden total,
aun asi puede ser util.


COMENTARIOS EN README.TXT

*************************************************************************/


#include <dos.h>
#include <stdio.h>
#include <malloc.h>
#include <conio.h>
#include <time.h>
#include <mem.h>
#include "st0rm.h"
#include "m68deb.h"





OperDef opers[] = {

{       0xc100,         0xf1f0,         "abcd",         NULL },
{       0xd000,         0xf000,         "add",          NULL },
{       0xd000,         0xf000,         "adda",         NULL },
{       0x0600,         0xff00,         "addi",         NULL },
{       0x5000,         0xf100,         "addq",         NULL },
{       0xd100,         0xf130,         "addx",         NULL },
{       0xc000,         0xf000,         "and",          NULL },
{       0x0200,         0xff00,         "andi",         NULL },
{       0xe100,         0xf118,         "asl r",        NULL },
{       0xe000,         0xf118,         "asr r",        NULL },
{       0xe1c0,         0xffc0,         "asl m",        NULL },
{       0xe0c0,         0xffc0,         "asr m",        NULL },
{       0x6400,         0xff00,         "bcc",          NULL },
{       0x6500,         0xff00,         "bcs",          0 },
{       0x6600,         0xff00,         "bne",          0 },
{       0x6700,         0xff00,         "beq",          0 },
{       0x6800,         0xff00,         "bvc",          0 },
{       0x6900,         0xff00,         "bvs",          0 },
{       0x6a00,         0xff00,         "bpl",          0 },
{       0x6b00,         0xff00,         "bmi",          0 },
{       0x6c00,         0xff00,         "bge",          0 },
{       0x6d00,         0xff00,         "blt",          0 },
{       0x6e00,         0xff00,         "bgt",          0 },
{       0x6f00,         0xff00,         "ble",          0 },
{       0x0140,         0xf1c0,         "bchg",         0 },
{       0x0180,         0xf1c0,         "bclr r",       0 },
{       0x0880,         0xffc0,         "bclr d",       0 },
{       0x6000,         0xff00,         "bra",          0 },
{       0x01c0,         0xf1c0,         "bset",         0 },
{       0x6100,         0xff00,         "bsr",          0 },
{       0x0100,         0xf1c0,         "btst r",       0 },
{       0x0800,         0xffc0,         "btst d",       0 },
{       0x4000,         0xf040,         "chk",          0 },
{       0x4200,         0xff00,         "clr",          0 },
{       0x9fcf,         0xffff,         "clr stack",    0 },
{       0xb000,         0xf000,         "cmp",          0 },
{       0x0c00,         0xff00,         "cmpi",         0 },
{       0xb108,         0xf138,         "cmpm",         0 },
{       0x51c8,         0xfff8,         "dbra",         0 },
{       0x54c8,         0xfff8,         "dbcc",         0 },
{       0x55c8,         0xfff8,         "dbcs",         0 },
{       0x56c8,         0xfff8,         "dbne",         0 },
{       0x57c8,         0xfff8,         "dbeq",         0 },
{       0x58c8,         0xfff8,         "dbvc",         0 },
{       0x59c8,         0xfff8,         "dbvs",         0 },
{       0x5ac8,         0xfff8,         "dbpl",         0 },
{       0x5bc8,         0xfff8,         "dbmi",         0 },
{       0x5cc8,         0xfff8,         "dbge",         0 },
{       0x5dc8,         0xfff8,         "dblt",         0 },
{       0x5ec8,         0xfff8,         "dbgt",         0 },
{       0x5fc8,         0xfff8,         "dble",         0 },
{       0x81c0,         0xf1c0,         "divs",         0 },
{       0x80c0,         0xf1c0,         "divu",         0 },
{       0xb000,         0xf000,         "eor",          0 },
{       0x0a00,         0xff00,         "eori",         0 },
{       0xc100,         0xf100,         "exg",          0 },
{       0x4800,         0xfe38,         "ext",          0 },
{       0x4afc,         0xffff,         "illegal",      0 },
{       0x4ec0,         0xffc0,         "jmp",          0 },
{       0x4e80,         0xffc0,         "jsr",          0 },
{       0x41c0,         0xf1c0,         "lea",          0 },
{       0x4e50,         0xfff8,         "link",         0 },
{       0xe108,         0xf118,         "lsl r",        0 },
{       0xe008,         0xf118,         "lsr r",        0 },
{       0xe3c0,         0xffc0,         "lsl m",        0 },
{       0xe2c0,         0xffc0,         "lsr m",        0 },
{       0x0000,         0xc000,         "move",         0 },
{       0x0040,         0xc1c0,         "movea",        0 },
{       0x46c0,         0xffc0,         "movetccr",     0 },
{       0x44c0,         0xffc0,         "movetsr",      0 },
{       0x40c0,         0xffc0,         "movefsr",      0 },
{       0x4880,         0xfb80,         "movem",        0 },
{       0x0008,         0xf038,         "movep",        0 },
{       0x7000,         0xf100,         "moveq",        0 },
{       0x4e60,         0xfff0,         "moveusp",      0 },
{       0xc1c0,         0xf1c0,         "muls",         0 },
{       0xc0c0,         0xf1c0,         "mulu",         0 },
{       0x4800,         0xffc0,         "nbcd",         0 },
{       0x4400,         0xff00,         "neg",          0 },
{       0x4000,         0xff00,         "negx",         0 },
{       0x4e71,         0xffff,         "nop",          0 },
{       0x4600,         0xff00,         "not",          0 },
{       0x8000,         0xf000,         "or",           0 },
{       0x0000,         0xff00,         "ori",          0 },  
{       0x007c,         0xffff,         "oritccr",      0 },  //0x003c
{       0x4840,         0xffc0,         "pea",          0 },
{       0xe118,         0xf118,         "rol r",        0 },
{       0xe018,         0xf118,         "ror r",        0 },
{       0xe7c0,         0xffc0,         "rol m",        0 },
{       0xe6c0,         0xffc0,         "ror m",        0 },
{       0xe110,         0xf118,         "roxl r",       0 },
{       0xe010,         0xf118,         "roxr r",       0 },
{       0xe5c0,         0xffc0,         "roxl m",       0 },
{       0xe4c0,         0xffc0,         "roxr m",       0 },
{       0x4e77,         0xffff,         "rtr",          0 },
{       0x4e75,         0xffff,         "rts",          0 },
{       0x8100,         0xf1f0,         "sbcd",         0 },
{       0x54c0,         0xffc0,         "scc",          0 },
{       0x55c0,         0xffc0,         "scs",          0 },
{       0x56c0,         0xffc0,         "sne",          0 },
{       0x57c0,         0xffc0,         "seq",          0 },
{       0x58c0,         0xffc0,         "svc",          0 },
{       0x59c0,         0xffc0,         "svs",          0 },
{       0x5ac0,         0xffc0,         "spl",          0 },
{       0x5bc0,         0xffc0,         "smi",          0 },
{       0x5cc0,         0xffc0,         "sge",          0 },
{       0x5dc0,         0xffc0,         "slt",          0 },
{       0x5ec0,         0xffc0,         "sgt",          0 },
{       0x5fc0,         0xffc0,         "sle",          0 },
{       0x9000,         0xf000,         "sub",          0 },
{       0x0400,         0xff00,         "subi",         0 },
{       0x5100,         0xf100,         "subq",         0 },
{       0x9100,         0xf130,         "subx",         0 },
{       0x4840,         0xfff8,         "swap",         0 },
{       0x4ac0,         0xffc0,         "tas",          0 },
{       0x4e40,         0xfff0,         "trap",         0 },
{       0x4e76,         0xffff,         "trapv",        0 },
{       0x4a00,         0xff00,         "tst",          0 },
{       0x4e58,         0xfff8,         "unlk",         0 },
{       0,              0,              NULL,           NULL }       

};



char *GiveOpCodeName (u_short cmp) {

  int                   cnt             = 0;
  u_short               tst;
//u_short               cmp             = GivePcOp ();


  while (1) {

        if (!opers[cnt].op_name) return NULL;
        tst = cmp & opers[cnt].op_mask;

        if (tst == opers[cnt].op_code) {
                opers[cnt].op_called    = cmp;
                opers[cnt].debug        = 1;
                //if (opers[cnt].op_func (&opers[cnt]))
                        return (opers[cnt].op_name);
        }

        cnt++;
  }
}



        
