/*************************************************************************

                          st0rm SGE Source Code

                          (c)1998 David Sanchez
                           st0rm@melodysoft.com

                        Released on 17th March 1999
        

Este codigo fuente lo puedes utilizar para:

- Usarlo como fuente de informacin para tus proyectos.
- Continuar el proyecto st0rm.
- Empezar un emulador desde 0 teniendo este como base.

Lo nico que pido si te es util y lo usas, es que lo menciones en tu
proyecto.

Tendras que perdonarme la falta de comentarios y el desorden total,
aun asi puede ser util.


COMENTARIOS EN README.TXT

*************************************************************************/


#include <dos.h>
#include <i86.h>
#include <stdio.h>
#include <malloc.h>
#include <conio.h>
#include <time.h>
#include <mem.h>
#include "vga.h"
#include "misc.h"
#include "header.h"
#include "st0rm.h"
#include "memory.h"
#include "m68k.h"
#include "m68misc.h"
#include "vdp.h"
#include "vdpmisc.h"
#include "vdprf.h"
#include "genio.h"
#include "vesa20.h"
#include "uclock.h"
#include "gui.h"
#include "sound.h"
#include "gensnd.h"
#include "z80.h"


char   *sizes[]         = {     "Byte",
                                "Word",
                                "DWord"
                          };

char   *id_codes[]      = {     "VRAM Read",
                                "VRAM Write",
                                "Unknown",
                                "CRAM Write",
                                "VSRAM Read",
                                "VSRAM Write",
                                "Unknown",
                                "Unknown",
                                "CRAM Read"
                          };

char   *dma_modes[]     = {     "Memory to VRAM",
                                "Unknown",
                                "VRAM Fill",
                                "VRAM Copy"
                          };

char   *dma_codes[]     = {     "",
                                "VRAM",
                                "",
                                "CRAM",
                                "",
                                "VSRAM"
                          };

char   *horz_scrl_modes[] = {   "Overall",
                                "Prohibited",
                                "Each one cell",
                                "Each one line"
                          };

char   *vert_scrl_modes[] = {   "Overall",
                                "Each two cells"
                          };




struct  _vdp_           vdp;
u_short                *vdp_sr_ptr      = (u_short *)&vdp.vdp_sr;

u_long                  vdp_count       = 0;
u_long                  vdp_render      = 0;

u_long                  frame_skip      = 2;
u_long                  cnt_skip        = 0;

u_long                  cnt_dma_busy    = 0;
u_long                  cnt_vert_blk    = 105;
u_long                  cnt_horz_blk    = 42;
u_long                  cnt_vert_intr   = 0;
u_long                  cnt_vert_blkf   = 0;

extern char             flg_stop;
extern char             flg_debug;

u_char                  vid_buffer[0x30000];

u_char                  window_enable   = ~0;
u_char                  scrl_a_enable   = ~0;
u_char                  scrl_b_enable   = ~0;
u_char                  sprs_enable     = ~0;
u_char                  scrl_ln_enable  = ~0;
u_char                  timing_enable   = ~0;
u_char                  rf_enable       = 0;

u_char                  wait_sync       = 0;
u_char                  spr_flg         = 0;
u_long                  vdp_run         = 105;          //10500
u_char                  dma_request     = 0;

u_char                  vdp_write       = 0;

u_char                 *vram            = mem.ram.vram;
u_char                 *v_buffer        = vid_buffer;
u_char                  vdp_cell_mode;


void ExitAndDump (void);


void ResetVDP (void) {

  int           cnt;


  *vdp_sr_ptr = 0;

  vdp.vdp_sr.pal        = ((io.hw_version == 1) ? 1 : 0);
  vdp.vdp_sr.fifo_empt  = 1;
  vdp.vdp_sr.fifo_full  = 0;
  vdp.vdp_sr.vert_blk   = 1;
  vdp.vdp_sr.horz_blk   = 0;
  vdp.vdp_sr.dma_busy   = 0;
  vdp.vdp_sr.vert_intr  = 0;
  vdp.vdp_sr.odd_frame  = 0;


  for (cnt = 0; cnt < 26; cnt++) vdp.reg[cnt] = 0;

  vdp.id_code           = 0;
  vdp.run               = 0;

  vdp.vi_enable         = 0;
  vdp.hi_enable         = 0;
  vdp.display           = 0;
  vdp.dma_enable        = 0;
  vdp.h_cells           = 40;
  vdp.v_cells           = 28;
  vdp.back_color        = 0;
  vdp.cell_mode         = 1;
  vdp.drawing           = 0;
  vdp.pal_effect        = 0;

  vdp.hv_cnt            = 0;

  vdp_count             = 0;

  memset (vid_buffer, 0, 64000);
}

extern u_long c_time;

void RunVDP (void) {

  static        u_short         vdp_dest_addr   = 0;
  static        u_long          vdp_pass        = 0;
  static        uclock_t        last_clock      = 0;
  static        u_long          vi_pass         = 0;
  uclock_t                      new_clock;
  uclock_t                      dif_clock;
  u_long                        check_time;
  int                           cnt;

  if (!last_clock) {
        last_clock = usec_clock (NULL);
        if (!last_clock) last_clock = 1;
  }


  RunVDPIntr ();

  if (keys[1]) ExitAndDump ();

  if (!cnt_vert_blk) {

        CheckKeyb ();

        vdp.vdp_sr.vert_blk = 0;

        if (vdp.display) {

                new_clock = usec_clock (NULL);
                dif_clock = (new_clock - last_clock);

                if (new_clock == -1) dif_clock = 17000;

                if (dif_clock < 17000) {
                        while (dif_clock < 17000) {
                                Executen_CPU (10);
                                new_clock = usec_clock (NULL);
                                dif_clock = (new_clock - last_clock);
                        }

                        last_clock = usec_clock (NULL);
                        RenderVDP ();
                        cnt_skip = 0;

                } else {
                        last_clock = usec_clock (NULL);
                        if (dif_clock < 24000) {
                                RenderVDP ();
                                cnt_skip = 0;

                        } else {
                                cnt_skip++;
                                if (cnt_skip >= frame_skip) {
                                        RenderVDP ();
                                        cnt_skip = 0;
                                }
                        }
                }
        }

        if (vdp.vi_enable) {
                vdp.vdp_sr.vert_intr = 1;
                vdp.vdp_sr.vert_blk = 1;

                //M68kIntrRet (vdp.vert_intr);
                Call68kIntr (vdp.vert_intr);
                vdp.vdp_sr.vert_blk = 1;
                cnt_vert_blkf = 25;
                cnt_vert_intr = 2;
        }

        cnt_vert_blk = vdp_run;
        vdp.vdp_sr.vert_blk = 1;
  }
}


void RunVDPIntr (void) {

  static u_short        vdp_dest_addr   = 0;
  static u_long         cnt_viblk       = 0;
  static u_long         rpc             = 0;

  if (cnt_dma_busy) {
        if (!--cnt_dma_busy)
                vdp.vdp_sr.dma_busy = 0;
  }

  if (cnt_vert_intr) {
        if (!--cnt_vert_intr) {
                vdp.vdp_sr.vert_intr = 0;
        }
  }

  if (cnt_vert_blkf) {
        if (!--cnt_vert_blkf) {
                vdp.vdp_sr.vert_blk = 0;
        }
  }

  if (cnt_vert_blk) {
        
        if (!vdp_write) {
               if (!--cnt_vert_blk) {
                        vdp.vdp_sr.vert_blk = 0;
                }
        } else {
                vdp_write = 0;
                cnt_vert_blk = vdp_run;
        }
  }
}

#define GEN_TIMING 17000

void GoVDP (void) {

  static        u_short         vdp_dest_addr   = 0;
  static        u_long          vdp_pass        = 0;
  static        uclock_t        last_clock      = 0;
  static        u_long          vi_pass         = 0;
  uclock_t                      new_clock;
  uclock_t                      dif_clock;
  u_long                        act_time        = (wait_sync) ? 3000 : GEN_TIMING;
  u_long                        check_time;
  int                           cnt;
  int                           tmp;
  u_char                       *snd_buffer      = snd.buffer;
  u_char                       *z80_buffer      = mem.ram.z80_ram;

  if (!last_clock) {
        last_clock = usec_clock (NULL);
        if (!last_clock) last_clock = 1;
  }

  if (!CheckKeyb ()) {

        cnt_vert_blk = vdp_run;
        vdp.vdp_sr.vert_blk = 1;
        cnt_vert_blkf = 21;
        cnt_vert_intr = 2;
        cnt_skip = 0;
        return;
  }

  vdp.vdp_sr.vert_blk = 0;

  if (vdp.display) {

        if (timing_enable) {
                new_clock = usec_clock (NULL);
                dif_clock = (new_clock - last_clock);

                if (new_clock == -1) dif_clock = act_time;

                if (dif_clock <= act_time) {
                        while (dif_clock < act_time) {
                                Executen_CPU (10);
                                new_clock = usec_clock (NULL);
                                dif_clock = (new_clock - last_clock);
                        }

                        last_clock = usec_clock (NULL);
                        RenderVDP ();
                        cnt_skip = 0;

                } else {
                        last_clock = usec_clock (NULL);
                        if (wait_sync && (dif_clock < 4300)) {
                                RenderVDP ();
                                last_clock = usec_clock (NULL);
                                cnt_skip = 0;
                        } else {
                                cnt_skip++;
                                if (cnt_skip >= 10) {
                                        RenderVDP ();
                                        cnt_skip = 0;
                                }
                        }
                }
        } else {
                cnt_skip++;
                if (cnt_skip >= frame_skip) {
                        RenderVDP ();
                        cnt_skip = 0;
                }
        }
  }

  if (vdp.vi_enable) {
        vdp.vdp_sr.vert_intr = 1;
        vdp.vdp_sr.vert_blk = 1;

        Interrupt68k(6);
        Interrupt_Z80();
        vdp.vdp_sr.vert_blk = 1;
        cnt_vert_blkf = 21;
        cnt_vert_intr = 2;
  }

  cnt_vert_blk = vdp_run;
  vdp.vdp_sr.vert_blk = 1;
}


void StartGUI (void);

FLAG CheckKeyb (void) {

  if (!KbHited()) return 1;

  if (keys[1]) {

         StartGUI ();
         if (rom_loaded) {
                rom_loaded = 0;
                return 0;
         }

         return 1;
  }

  if (keys[0x3b]) window_enable         = ~window_enable;
  if (keys[0x3c]) scrl_a_enable         = ~scrl_a_enable;
  if (keys[0x3d]) scrl_b_enable         = ~scrl_b_enable;
  if (keys[0x3e]) sprs_enable           = ~sprs_enable;
  if (keys[0x58]) rf_enable             = ~rf_enable;

  return 1;
}


u_long ReadVDPPort (u_long addr, u_short size) {

  u_long                sum_vid;
  char                 *tmp_ptr;
  s_short               hv_cnt;
  static u_long         tmp             = 0;

  //PrintLog ("Read VDP port at %s %lx", sizes[size], addr);

  //vdp_write = 1;

  if (addr == 0xc00008 || addr == 0xc00009) {

        /*if (tmp++ < 100) return 0;
        if (tmp > 222) {
                tmp = 0;
                vdp.hv_cnt = 0;
        }*/
        /*if (cnt_vert_blk > 84) return 0;                // 84
        hv_cnt = (s_short)(-cnt_vert_blk) + 84;
        vdp.hv_cnt = (u_short)(hv_cnt*2) & 0xff;
        vdp.hv_cnt |= (vdp.hv_cnt << 8);*/
        
        PrintLog ("Read HV counter at %lx: %lx", addr, vdp.hv_cnt);

        return ((u_short)vdp.hv_cnt);
  }
   
  if (vdp.run && (addr >= 0xc00000 && addr < 0xc00004)) {

        sum_vid = (size * 2);
        if (!sum_vid) sum_vid = 1;

        switch (vdp.id_code) {

                case 0 :                        // VRAM READ
                         tmp_ptr = (char *)(mem.ram.vram + vdp.dest_addr);
                         vdp.dest_addr += sum_vid;

                         return (LoadFromVDPMem (tmp_ptr, size));

                case 4 :                        // VSRAM READ
                         tmp_ptr = (char *)(mem.ram.vsram + vdp.dest_addr);
                         vdp.dest_addr += sum_vid;

                         return (LoadFromVDPMem (tmp_ptr, size));

                case 8 :                        // CRAM READ
                         tmp_ptr = (char *)(mem.ram.cram + vdp.dest_addr);
                         vdp.dest_addr += sum_vid;

                         return (LoadFromVDPMem (tmp_ptr, size));

                default:
                         break;
        }
  }

  if (addr >= 0xc00004 && addr < 0xc00008) {

        if (!size && addr == 0xc00004)
                PrintELog ("Warning, reading byte status register at %lx", addr);

        PrintLog ("Reading status register : %x", *vdp_sr_ptr);
        return ((u_long) *vdp_sr_ptr);

  }

  if (addr == 0xc00011) return ((u_char)PSGRead ());

  PrintELog ("[VDP] Unknown read at %s %lx", sizes[size], addr);

  return (0);
}

void WriteVDPPort (u_long addr, u_short size, u_long to_write) {

  u_short               reg;
  u_char                data;
  char                 *tmp_ptr;
  int                   sum_vid;
  static u_long         mid_write;
  static char           flg_mw          = 0;
  static char           dma_vf_flg      = 0;


  vdp_write = 1;

  //if (addr == 0xc00004)
  //    PrintLog ("Write to VDP PORT %lx %s: %lx", addr, sizes[size], to_write);

  if (dma_vf_flg) {
        if (addr >= 0xc00000 && addr < 0xc00004) {
                vdp.dma_fdata = to_write;

                PrintLog ("Perfoming VRAM fill at addr %lx with %x",
                          vdp.dest_addr, to_write);
                DoDMA ();

        } else {

                /*PrintLog ("Performing DMA (%s) to %s, 68k=%lx vram=%lx",
                           dma_modes[vdp.dma_mode], dma_codes[vdp.id_code],
                           vdp.dma_addr, vdp.dest_addr);

                DoDMA ();*/
                
                PrintELog ("VRAM fill fails");
        }

        vdp.id_code = 0;
        vdp.run = 0;
        dma_vf_flg = 0;

        return;
  }

  if (flg_mw) {

        if ((size == 1) && (!(to_write & 0xff00)) && (addr >= 0xc00004 && addr <= 0xc00007)) {
                mid_write <<= 16;
                to_write |= mid_write;
                size = 2;

                //PrintLog ("Mid Write to %lx = %lx", addr, (u_long)to_write);
        } else {

                PrintELog ("Fail midwrite to %lx: mid=%lx, new=%lx",
                           addr, (u_long)mid_write, (u_long)to_write);
        }

        flg_mw = 0;
        mid_write = 0;
  }

  if (vdp.run && !(addr >= 0xc00000 && addr < 0xc00004)) {

        if (vdp.id_code == 3)
                DoCRAM ();

        PrintLog ("End of %s at addr %lx", id_codes[vdp.id_code],
                  vdp.dest_addr);

        vdp.id_code     = 0;
        vdp.run         = 0;
        vdp.dest_addr   = 0;

  } else if (vdp.run) {

        if (vdp.dest_addr & 1) PrintELog ("[VDPWARN] VRAM is ODD at %s %lx, reg15=%d",
                                          sizes[size], vdp.dest_addr, vdp.reg[15]);
        /*if (vdp.reg[15]!=2) PrintELog ("[VDPWARN] Write to VRAM at %s %lx, reg15=%d",
                                        sizes[size], vdp.dest_addr, vdp.reg[15]);*/

        switch (vdp.id_code) {

                case  1 :               // VRAM WRITE

                          /*PrintLog ("Write %s To VRAM at addr %lx : %lx, cnt = %d",
                                    sizes[size], vdp.dest_addr, (u_long)to_write,
                                    vdp.reg[15]);*/

                          tmp_ptr = (mem.ram.vram + vdp.dest_addr);

                          if (vdp.dest_addr > 0xffff) {
                                PrintELog ("[VDP] Illegal VRAM access at %x",
                                          vdp.dest_addr);
                                return;
                          }

                          /*if ((vdp.dest_addr >= vdp.base_spr) && \
                                (vdp.dest_addr <= (vdp.base_spr+350))) {
                                PrintELog ("[SPR] Write to Spr table at %s %x, spr_table=%x",
                                        sizes[size], vdp.dest_addr, vdp.base_spr);
                          }*/

                          //WriteToVDPMem (tmp_ptr, size, to_write);

                          //vdp.dest_addr += vdp.reg[15];

                          sum_vid = size * 2;
                          if (!sum_vid) sum_vid = 1;

                          //vdp.dest_addr += sum_vid;

                          if ((vdp.reg[15] > 2) && (size == 2)) {
                                WriteToVDPMem (tmp_ptr, 1, to_write >> 16);
                                WriteToVDPMem (tmp_ptr+vdp.reg[15], 1,
                                               to_write & 0xffff);
                                vdp.dest_addr += vdp.reg[15];

                          } else
                                WriteToVDPMem (tmp_ptr, size, to_write);

                          if (vdp.reg[15] > sum_vid)
                                vdp.dest_addr += vdp.reg[15];
                          else
                                vdp.dest_addr += sum_vid;


                          return;

                case  3 :               // CRAM WRITE

                          tmp_ptr = (mem.ram.cram + vdp.dest_addr);

                          if (vdp.dest_addr > 0x80)
                                PrintELog ("[VDP] Illegal CRAM access at %x",
                                          vdp.dest_addr);
                          else
                                WriteToVDPMem (tmp_ptr, size, to_write);

                          //vdp.dest_addr += vdp.reg[15];
                                
                          sum_vid = size * 2;
                          if (!sum_vid) sum_vid = 1;

                          vdp.dest_addr += sum_vid;

                          return;

                case  5 :               // VSRAM WRITE

                          /*PrintELog ("Writing to VSRAM at %s %x: %lx, reg15=%d",
                                     sizes[size], vdp.dest_addr, to_write, vdp.reg[15]);*/

                          tmp_ptr = (mem.ram.vsram + vdp.dest_addr);

                          if (vdp.dest_addr > 0x7f)
                                PrintELog ("[VDP] Illegal VSRAM access at %x, reg15=%d, data=%lx",
                                          vdp.dest_addr, vdp.reg[15], to_write);
                          else
                                WriteToVDPMem (tmp_ptr, size, to_write);

                          //vdp.dest_addr += vdp.reg[15];

                          sum_vid = size * 2;
                          if (!sum_vid) sum_vid = 1;

                          vdp.dest_addr += sum_vid;

                          return;

                default :
                          break;
        }
  }

  if ((size == 2) && ((to_write & 0xe0000000) == 0x80000000) && (addr >= 0xc00004 && addr <= 0xc00007)) {
        WriteVDPPort (addr, 1, to_write >> 16);  // mmmm
        WriteVDPPort (addr, 1, to_write & 0x0000ffff);
        return;
  }

  if ((size == 2) && ((to_write & 0xe000) == 0x8000) && (addr >= 0xc00004 && addr <= 0xc00007)) {
        WriteVDPPort (addr, 1, to_write >> 16);
        WriteVDPPort (addr, 1, to_write & 0x0000ffff);
        return;
  }

  /*PrintLog ("Write VDP port at %s %lx : %lx", sizes[size], addr,
           (u_long)to_write);*/

  if (((to_write & 0xe000) == 0x8000) && (addr >= 0xc00004 && addr <= 0xc00007)) {

        reg = (to_write >> 8) & 0x1f;
        data = (u_char)(to_write & 0xff);

        if (reg > 25)
                PrintELog ("[VDP] Unknown write to VDP reg %d: %x", reg, data);
        else
                vdp.reg[reg] = (u_char)data;

        //PrintLog ("Writing to VDP reg %d : %x", reg, data);
        CtrlVDPReg (reg);
        return;
  }

  if ((size == 1) && (addr >= 0xc00004 && addr <= 0xc00007)) {

        mid_write = 0;
        mid_write = to_write;
        flg_mw = 1;

        //PrintLog ("MidWrite: %lx, size=%d", mid_write, size);

        return;
  }

  if ((size == 2) && (addr == 0xc00004 || addr == 0xc00006)) {

        vdp.id_code = 0;
        vdp.id_code = ((to_write >> 30) & 0x3);
        vdp.id_code |= (((to_write >> 2) & 0x1c));  // 0x3c

        vdp.dest_addr = 0;
        vdp.dest_addr = ((to_write >> 16) & 0x3fff);
        vdp.dest_addr |= (((to_write << 14) & 0xc000));


        //if ((vdp.id_code & 0x38) == 0x20) {

        if (dma_request) {

                dma_request = 0;

                //CtrlVDPReg (23);

                vdp.id_code &= 0x3;

                if (vdp.dma_mode == 2) {
                        dma_vf_flg = 1;
                        return;
                }

                PrintLog ("Performing DMA (%s) to %s, 68k=%lx vram=%lx, to_write=%lx",
                           dma_modes[vdp.dma_mode], dma_codes[vdp.id_code],
                           vdp.dma_addr, vdp.dest_addr, to_write);

                DoDMA ();

                vdp.run         = 0;
                vdp.id_code     = 0;

                return;
        }

        if ((vdp.id_code == 2) || (vdp.id_code == 6) || \
            (vdp.id_code == 7) || (vdp.id_code > 8)) {

                PrintELog ("Unknown mode %x at addr %lx", vdp.id_code,
                           vdp.dest_addr);
                return;
        }

        PrintLog ("Requested %s at addr %lx, reg15=%d", id_codes[vdp.id_code],
                  vdp.dest_addr, vdp.reg[15]);

        vdp.run = 1;

        return;
  }

  if (addr == 0xc00011) {
        PSGWrite ((u_char)to_write);
        return;
  }

  PrintELog ("[VDP] Unknown write at %s %lx: %lx", sizes[size], addr, to_write);
}

void WriteToVDPMem (char *dest, u_short cnt, u_long to_write) {

  if (cnt == 0) {
        *dest = (u_char)to_write;
        return;
  }

  if (cnt == 1) {
        (*(u_short *)dest) = (u_short) RorShort(to_write);
        return;
  }

  (*(u_long *)dest) = (u_long) RorLong(to_write);
}

u_long LoadFromVDPMem (char *from, u_short size) {

  if (size == 0)
        return (*from);

  if (size == 1)
        return (RorShort ((*(u_short *)from)));

  return (RorLong ((*(u_long *)from)));
}

void CtrlVDPReg (u_short reg) {

  u_long        tmp;


  switch (reg) {

        case 0  :
                  vdp.hi_enable = (vdp.reg[0] >> 4) & 1;

                  if (vdp.reg[0] & 2) vdp.hv_cnt = 0;

                  if (vdp.reg[0] & 2)
                        PrintLog ("HV Counter stop");
                  else
                        PrintLog ("HV Counter read enable");

                  if (!vdp.hi_enable)
                        PrintLog ("Horz interrupt disabled");
                  else
                        PrintLog ("Horz interrupt enabled");
                  break;

        case 1  :
                  vdp.display = (vdp.reg[1] >> 6) & 1;
                  vdp.vi_enable = (vdp.reg[1] >> 5) & 1;
                  vdp.dma_enable = (vdp.reg[1] >> 4) & 1;

                  if ((vdp.reg[1] >> 3) & 1) vdp.v_cells = 30;
                        else vdp.v_cells = 28;

                  if (!vdp.display)
                        PrintLog ("Display disabled");
                  else
                        PrintLog ("Display enabled");

                  if (!vdp.vi_enable)
                        PrintLog ("Vert interrupt disabled");
                  else
                        PrintLog ("Vert interrupt enabled");

                  if (!vdp.dma_enable)
                        PrintLog ("DMA disabled");
                  else
                        PrintLog ("DMA enabled");

                  PrintLog ("Setting V cells: %d", vdp.v_cells);
                  break;

        case 2  :
                  vdp.base_scrl_a = ((vdp.reg[2] >> 3) & 7);
                  vdp.base_scrl_a <<= 13;

                  PrintLog ("Setting base scroll A at %x", vdp.base_scrl_a);
                  break;

        case 3  :

                  vdp.base_win = (vdp.reg[3] & 0x3f);
                  vdp.base_win <<= 10;

                  PrintLog ("Setting base window at %x", vdp.base_win);
                  break;

        case 4  :
                  vdp.base_scrl_b = (vdp.reg[4] & 7);
                  vdp.base_scrl_b <<= 13;

                  PrintLog ("Setting base scroll B at %x", vdp.base_scrl_b);
                  break;

        case 5  :
                  vdp.base_spr = (vdp.reg[5] & 0x7f);
                  vdp.base_spr <<= 9;

                  PrintLog ("Setting base sprite at %x", vdp.base_spr);
                  break;

        case 7  :
                  vdp.back_color = (vdp.reg[7] & 0xf);
                  vdp.back_color += (16 * ((vdp.reg[7] >> 4) & 3)) + 16;

                  PrintLog ("Setting background color to %d", vdp.back_color);
                  break;

        case 10 :
                  PrintLog ("HV Counter Cnt = %d", vdp.reg[10]);
                  break;

        case 11 :
                  vdp.ei_enable = (vdp.reg[11] >> 3) & 1;
                  vdp.scrl_mode_v = (vdp.reg[11] >> 2) & 1;
                  vdp.scrl_mode_h = (vdp.reg[11] & 0x3);

                  PrintLog ("Horizontal scrl mode: %s",
                        horz_scrl_modes[vdp.scrl_mode_h]);

                  PrintLog ("Vertical scrl mode: %s",
                        vert_scrl_modes[vdp.scrl_mode_v]);

                  //PrintLog ("Reg11 = %x", vdp.reg[11]);

                  if (!vdp.ei_enable)
                        PrintLog ("External interrupt disabled");
                  else
                        PrintLog ("External interrupt enabled");

                  break;

        case 12 :
                  vdp.cell_mode = (vdp.reg[12] >> 7);
                  vdp.vid_mode  = (vdp.reg[12] & 3);

                  vdp_cell_mode = vdp.cell_mode;

                  if (!vdp.cell_mode) vdp.h_cells = 32;
                        else vdp.h_cells = 40;

                  switch (vdp.vid_mode) {

                        case 0 : PrintLog ("No Interlace mode");
                                 break;
                        case 1 : PrintLog ("Interlace mode");
                                 break;
                        case 2 : PrintLog ("PROHIBITED mode");
                                 break;
                        case 3 : PrintLog ("Interlace (HiRes) mode");
                                 break;
                  }

                  if (!vdp.cell_mode)
                        PrintLog ("32 cell mode");
                  else
                        PrintLog ("40 cell mode");

                  break;

        case 13 :
                  vdp.base_scrl_h = (vdp.reg[13] & 0x3f);
                  vdp.base_scrl_h <<= 10;

                  PrintLog ("Setting base scroll H at %x", vdp.base_scrl_h);
                  //PrintLog ("reg13=%lx", vdp.reg[13]);
                  break;

        case 15 :
                  PrintLog ("Setting autoincrement to %d", (s_char)vdp.reg[15]);
                  break;

        case 16 :
                  switch (vdp.reg[16] & 0x03) {

                        case 0  : vdp.scrl_size_h = 32; break;
                        case 1  : vdp.scrl_size_h = 64; break;
                        case 2  : vdp.scrl_size_h = 0; break;
                        case 3  : vdp.scrl_size_h = 128; break;
                  }

                  switch ((vdp.reg[16] >> 4) & 0x03) {

                        case 0  : vdp.scrl_size_v = 32; break;
                        case 1  : vdp.scrl_size_v = 64; break;
                        case 2  : vdp.scrl_size_v = 0; break;
                        case 3  : vdp.scrl_size_v = 128; break;
                  }

                  PrintLog ("Setting scroll size HxV = %dx%d",
                            vdp.scrl_size_h, vdp.scrl_size_v);
                  break;

        case 17 :
                  vdp.win_h_pos = vdp.reg[17];
                  vdp.win_h_pos <<= 1;
                  vdp.win_h_pos |= (vdp.reg[17] & 0x80);

                  PrintLog ("Setting window H Pos: %d", vdp.win_h_pos);
                  break;

        case 18 :
                  vdp.win_v_pos = vdp.reg[18];
                
                  PrintLog ("Setting window V Pos: %d", vdp.win_v_pos);
                  break;

        case 23 :
                  if (!(vdp.reg[23] & 0x80)) vdp.dma_mode = 0;
                        else vdp.dma_mode = ((vdp.reg[23] >> 6) & 0x3);

                  vdp.dma_addr = (u_char)vdp.reg[21];
                  tmp = (u_char)vdp.reg[22]; tmp <<= 8;
                  vdp.dma_addr |= tmp;
                  tmp = (u_char)vdp.reg[23];
                  tmp &= ((vdp.dma_mode) ? 0x3f : 0x7f); tmp <<= 16;
                  vdp.dma_addr |= tmp;

                  vdp.dma_addr <<= 1;

                  vdp.dma_cnt = (u_char)vdp.reg[19];
                  tmp = (u_char)vdp.reg[20]; tmp <<= 8;
                  vdp.dma_cnt |= tmp;

                  dma_request = 1;

                  PrintLog ("[DMA] Mode %s cnt=%lx addr=%lx",
                            dma_modes[vdp.dma_mode], vdp.dma_cnt,
                            vdp.dma_addr);

                  /*PrintLog ("reg21=%lx, reg22=%lx, reg23=%lx",
                            (u_char)vdp.reg[21], (u_char)vdp.reg[22],
                            (u_char)vdp.reg[23]);*/
                  break;

        case 24 :
        case 25 :
                  PrintELog ("[VDP] Unknown write to VDP reg %d: %x", reg,
                             vdp.reg[reg]);
                  break;
        default :
                  if ((reg < 19) && vdp.reg[reg])
                        PrintELog ("[VDP] Unknown write to VDP reg %d: %x",
                                   reg, vdp.reg[reg]);
                  break;
  }
}

void DoDMA (void) {

  char         *src;
  char         *dest;
  u_short       count   = vdp.dma_cnt;
  int           cnt;
  u_short      *wsrc, *wdest;
  u_long       *lsrc, *ldest;
  u_char        tmpc;


  if (!vdp.dma_enable) return;

  /*if ((vdp.dest_addr >= 0x8000) && (vdp.dest_addr <= 0x9200)) {
        //vdp.dma_addr >>= 1;
        PrintELog ("[VDPWARN] DMA PFAIL at %x from %lx, cnt=%lx, reg15=%d",
                   vdp.dest_addr, vdp.dma_addr, count, vdp.reg[15]);
        OpDebug();
  }*/
    /*else
        PrintELog ("[VDPWARN] DMA SW at %x from %lx, cnt=%lx, reg15=%d",
                   vdp.dest_addr, vdp.dma_addr, count, vdp.reg[15]);*/
        
  
  if (!vdp.dma_mode) {

        if (vdp.dma_addr <= 0x3fffff) {
                src = (mem.rom_space + vdp.dma_addr);

        } else if (vdp.dma_addr >= 0xff0000 && vdp.dma_addr <= 0xffffff) {

                src = (mem.ram.ram_space + (vdp.dma_addr - 0xff0000));
        } else if (vdp.dma_addr >= 0xfe0000 && vdp.dma_addr <= 0xfeffff) {

                src = (mem.ram.ram_space + (vdp.dma_addr - 0xfe0000));
        } else {
                PrintELog ("Unknown DMA addr at %lx", vdp.dma_addr);
                return;
        }
  }

  if (vdp.dest_addr & 1)
        PrintELog ("[VDPWARN] DMA to VRAM ODD at %lx, reg15=%d",
                  vdp.dest_addr, vdp.reg[15]);
  /*if (vdp.reg[15]!=2 && vdp.dma_mode!=2)
        PrintELog ("[VDPWARN] DMA to VRAM at %lx, reg15=%d",
                  vdp.dest_addr, vdp.reg[15]);*/

  /*if ((vdp.dest_addr >= vdp.base_spr) && (vdp.dest_addr <= (vdp.base_spr+350))) {

        PrintELog ("[SPR] DMA to Spr table at %x from %lx, cnt=%lx, spr_table=%x, reg15=%d",
                   vdp.dest_addr, vdp.dma_addr, count, vdp.base_spr, vdp.reg[15]);
  }*/


  switch (vdp.id_code) {

        case 1 :
                 if (vdp.dest_addr > 0xffff) {
                        PrintELog ("[DMA] Bad VRAM addr: %lx", vdp.dest_addr);
                        return;
                 }

                 dest = (mem.ram.vram + vdp.dest_addr);
                 break;
        case 3 :
                 if (vdp.dest_addr > 0x80) {
                        PrintELog ("[DMA] Bad CRAM addr: %lx", vdp.dest_addr);
                        return;
                 }

                 dest = (mem.ram.cram + vdp.dest_addr);
                 break;
        case 5 :
                 if (vdp.dest_addr > 0x4f) {
                        PrintELog ("[DMA] Bad VSRAM addr: %lx", vdp.dest_addr);
                        return;
                 }

                 dest = (mem.ram.vsram + vdp.dest_addr);
                 break;
        default:
                 PrintELog ("[DMA] Unknown DMA target: %d", vdp.id_code);
                 return;
  }

  wdest = (u_short *)dest;
  wsrc  = (u_short *)src;

  switch (vdp.dma_mode) {

        case  0 :
                  /*if (!(count%2)) {

                        count /= 2;
                        ldest = (u_long *)wdest;
                        lsrc  = (u_long *)wsrc;

                        for (cnt = 0; cnt < count; cnt++)
                                *ldest++ = *lsrc++;

                  } else {

                        for (cnt = 0; cnt < count; cnt++) {
                                *wdest++ = *wsrc++;
                        }

                  }*/

                  /*for (cnt = 0; cnt < (count*2); cnt++) {
                        *dest = *src++;
                        dest += (vdp.reg[15]/2);
                  }*/

                  tmpc = vdp.reg[15];
                  tmpc /= 2;

                  for (cnt = 0; cnt < count; cnt++) {
                        *wdest = *wsrc++;
                        wdest += tmpc;
                  }

                  if (vdp.id_code == 3) DoCRAM ();

                  break;

        case  2 :
                  for (cnt = 0; cnt < count; cnt++) {
                        *dest = vdp.dma_fdata;
                        dest += vdp.reg[15];
                  }

                  break;
        default :
                  PrintELog ("DMA mode not supported");
                  break;
  }

  vdp.reg[1] &= 0xef;
  //vdp.vdp_sr.dma_busy = 1;
  cnt_dma_busy = 1;
}

void DoCRAM (void) {

  u_short              *src             = (u_short *)mem.ram.cram;
  int                   cnt             = 64;
  u_short               tmp;
  u_char                exit_flg        = 0;

  if (!flg_stop && flg_debug) return;

  if (vdp.drawing) {
        //if (vdp.pal_effect) return;
        outp (0x3c8, 80);
        vdp.pal_effect = 1;
        exit_flg = 1;
  } else
        outp (0x3c8, 16);

  for (cnt = 0; cnt < 64; cnt++) {

        tmp = RorShort (*src++);       

        outp (0x3c9, ((tmp & 0xf) << 2));
        outp (0x3c9, ((tmp >> 4) & 0xf) << 2);
        outp (0x3c9, ((tmp >> 8) & 0xf) << 2);
  }

  if (exit_flg) return;

  outp (0x3c8, 144);

  src = (u_short *)mem.ram.cram;

  for (cnt = 0; cnt < 64; cnt++) {

        tmp = RorShort (*src++);       

        outp (0x3c9, ((tmp & 0xf) << 2));
        outp (0x3c9, ((tmp >> 4) & 0xf) << 2);
        outp (0x3c9, ((tmp >> 8) & 0xf) << 2);
  }
}

void RenderVDP (void) {

  vdp_render++;

  if (rf_enable) {
        RenderVDPLineRaster ();
        return;
  }

  if ((vdp.scrl_mode_h == 3) && scrl_ln_enable) {
        RenderVDPLine ();
        return;
  }

  if (vdp.scrl_mode_h == 2) {
        RenderVDPCell ();
        return;
  }

  RenderVDPOverall ();
}

void RenderVDPOverall (void) {

  u_short      *w_scrl_a        = (u_short *)(mem.ram.vram + vdp.base_scrl_a);
  u_short      *w_scrl_b        = (u_short *)(mem.ram.vram + vdp.base_scrl_b);
  u_short      *n_scrl_a;
  u_short      *n_scrl_b;
  u_short      *h_scrl          = (u_short *)(mem.ram.vram + vdp.base_scrl_h);
  s_short       h_desp_a        = RorShort (*h_scrl++);
  s_short       h_desp_b        = RorShort (*h_scrl);
  s_short       h_cell_a;
  s_short       h_cell_b;
  u_short      *v_scrl          = (u_short *)(mem.ram.vsram);
  s_short       v_desp_a        = RorShort (*v_scrl++);
  s_short       v_desp_b        = RorShort (*v_scrl);
  s_short       v_cell_a;
  s_short       v_cell_b;
  u_short       next;
  int           y, x;



  h_desp_a      = (-h_desp_a);
  h_desp_b      = (-h_desp_b);
  h_desp_a      = (h_desp_a % (vdp.scrl_size_h * 8));
  h_desp_b      = (h_desp_b % (vdp.scrl_size_h * 8));
  h_cell_a      = h_desp_a / 8;
  h_cell_b      = h_desp_b / 8;
  h_desp_a     %= 8;
  h_desp_b     %= 8;

  v_desp_a      = (v_desp_a % (vdp.scrl_size_v * 8));
  v_desp_b      = (v_desp_b % (vdp.scrl_size_v * 8));
  v_cell_a      = v_desp_a / 8;
  v_cell_b      = v_desp_b / 8;
  v_desp_a     %= 8;
  v_desp_b     %= 8;


  memset (vid_buffer, vdp.back_color, 0x15000);
  //memset (vid_buffer+0x15000, 0, 0x15000);


  if (scrl_b_enable) {

    v_cell_b--;

    if (v_cell_b < 0) v_cell_b = (vdp.scrl_size_v + v_cell_b);

    w_scrl_b += (v_cell_b * vdp.scrl_size_h);

    for (y = 0; y < (vdp.v_cells+2); y++) {

        if (h_cell_b <= 0) h_cell_b = (vdp.scrl_size_h + h_cell_b);

        DoCELLH ((y*8) - v_desp_b, w_scrl_b, h_cell_b, h_desp_b,
                 vdp.h_cells, vdp.scrl_size_h);

        w_scrl_b += vdp.scrl_size_h;

        if ((y + v_cell_b + 2) > vdp.scrl_size_v) {
                w_scrl_b = (u_short *)(mem.ram.vram + vdp.base_scrl_b);
                v_cell_b = 0;
        }
    }
  }


  if (scrl_a_enable) {

    v_cell_a--;

    if (v_cell_a < 0) v_cell_a = (vdp.scrl_size_v + v_cell_a);

    w_scrl_a += (v_cell_a * vdp.scrl_size_h);

    for (y = 0; y < (vdp.v_cells+2); y++) {

        if (h_cell_a <= 0) h_cell_a = (vdp.scrl_size_h + h_cell_a);

        DoCELLH ((y*8) - v_desp_a, w_scrl_a, h_cell_a, h_desp_a,
                 vdp.h_cells, vdp.scrl_size_h);

        w_scrl_a += vdp.scrl_size_h;
        
        if ((y + v_cell_a + 2) > vdp.scrl_size_v) {
                w_scrl_a = (u_short *)(mem.ram.vram + vdp.base_scrl_a);
                v_cell_a = 0;
        }
    }
  }

  if (window_enable) ShowWindow ();

  if (sprs_enable) ShowSprs ();

  if (wait_sync) WaitSync ();

  ShowVGA  ();
}

void RenderVDPCell (void) {

  u_short      *w_scrl_a        = (u_short *)(mem.ram.vram + vdp.base_scrl_a);
  u_short      *w_scrl_b        = (u_short *)(mem.ram.vram + vdp.base_scrl_b);
  u_short      *n_scrl_a;
  u_short      *n_scrl_b;
  u_short      *h_scrl          = (u_short *)(mem.ram.vram + vdp.base_scrl_h);
  u_short      *h_scrl_a        = h_scrl-16;
  u_short      *h_scrl_b        = (h_scrl-15);
  s_short       h_desp_a;
  s_short       h_desp_b;
  s_short       h_cell_a;
  s_short       h_cell_b;
  u_short      *v_scrl          = (u_short *)(mem.ram.vsram);
  s_short       v_desp_a        = RorShort (*v_scrl++);
  s_short       v_desp_b        = RorShort (*v_scrl);
  s_short       v_cell_a;
  s_short       v_cell_b;
  u_short       next;
  int           y, x;



  v_desp_a      = (v_desp_a % (vdp.scrl_size_v * 8));
  v_desp_b      = (v_desp_b % (vdp.scrl_size_v * 8));
  v_cell_a      = v_desp_a / 8;
  v_cell_b      = v_desp_b / 8;
  v_desp_a     %= 8;
  v_desp_b     %= 8;


  memset (vid_buffer, vdp.back_color, 0x15000);
  //memset (vid_buffer+0x15000, 0, 0x15000);


  if (scrl_b_enable) {

    v_cell_b--;

    if (v_cell_b < 0) v_cell_b = (vdp.scrl_size_v + v_cell_b);

    w_scrl_b += (v_cell_b * vdp.scrl_size_h);

    for (y = 0; y < (vdp.v_cells+2); y++) {

        h_desp_b        = RorShort (*h_scrl_b);
        h_desp_b        = (-h_desp_b);
        h_desp_b        = (h_desp_b % (vdp.scrl_size_h * 8));
        h_cell_b        = h_desp_b / 8;
        h_desp_b       %= 8;
        h_scrl_b       += 16;

        n_scrl_b = w_scrl_b;

        if (h_cell_b <= 0) h_cell_b = (vdp.scrl_size_h + h_cell_b);

        w_scrl_b += (h_cell_b - 1);

        for (x = 0; x < (vdp.h_cells + 2); x++) {

                if ((x + h_cell_b) > vdp.scrl_size_h) {
                        next = RorShort (*n_scrl_b++);
                        w_scrl_b++;
                } else
                        next = RorShort (*w_scrl_b++);

                if (next & 0x7ff) {
                        DoCELLAsm ((u_long)next, (long)((y*8) - v_desp_b),
                                  (long)((x*8) - h_desp_b));
                }
        }

        w_scrl_b += (vdp.scrl_size_h - (vdp.h_cells + h_cell_b + 1));

        if ((y + v_cell_b + 2) > vdp.scrl_size_v) {
                w_scrl_b = (u_short *)(mem.ram.vram + vdp.base_scrl_b);
                v_cell_b = 0;
        }
    }
  }


  if (scrl_a_enable) {

    v_cell_a--;

    if (v_cell_a < 0) v_cell_a = (vdp.scrl_size_v + v_cell_a);

    w_scrl_a += (v_cell_a * vdp.scrl_size_h);

    for (y = 0; y < (vdp.v_cells+2); y++) {

        h_desp_a        = RorShort (*h_scrl_a);
        h_desp_a        = (-h_desp_a);
        h_desp_a        = (h_desp_a % (vdp.scrl_size_h * 8));
        h_cell_a        = h_desp_a / 8;
        h_desp_a       %= 8;
        h_scrl_a       += 16;
        
        n_scrl_a = w_scrl_a;

        if (h_cell_a <= 0) h_cell_a = (vdp.scrl_size_h + h_cell_a);

        w_scrl_a += (h_cell_a - 1);

        for (x = 0; x < (vdp.h_cells + 2); x++) {

                if ((x + h_cell_a) > vdp.scrl_size_h) {
                        next = RorShort (*n_scrl_a++);
                        w_scrl_a++;
                } else
                        next = RorShort (*w_scrl_a++);

                if (next & 0x7ff) {
                        DoCELLAsm ((u_long)next, (long)((y*8) - v_desp_a),
                                  (long)((x*8) - h_desp_a));
                }
        }

        w_scrl_a += (vdp.scrl_size_h - (vdp.h_cells + h_cell_a + 1));

        if ((y + v_cell_a + 2) > vdp.scrl_size_v) {
                w_scrl_a = (u_short *)(mem.ram.vram + vdp.base_scrl_a);
                v_cell_a = 0;
        }
    }
  }

  if (window_enable) ShowWindow ();

  if (sprs_enable) ShowSprs ();

  if (wait_sync) WaitSync ();

  ShowVGA  ();
}


void RenderVDPLine (void) {

  s_short      *h_scrl          = (s_short *)(mem.ram.vram + vdp.base_scrl_h);
  s_short      *h_scrl_a        = h_scrl;
  s_short      *h_scrl_b        = h_scrl;
  u_short      *v_scrl          = (u_short *)(mem.ram.vsram);
  s_short       v_desp_a        = RorShort (*v_scrl++);
  s_short       v_desp_b        = RorShort (*v_scrl);
  s_short       v_cell_a;
  s_short       v_cell_b;
  u_short       v_lines         = vdp.v_cells * 8;
  u_char        hint_cnt        = 0;
  long          y, x;
  u_short       next;


  rd_buffer_pos = (u_char *)(v_buffer+(336*8));
  rd_ptr_scrl_a = (u_short *)(mem.ram.vram + vdp.base_scrl_a);
  rd_ptr_scrl_b = (u_short *)(mem.ram.vram + vdp.base_scrl_b);

  v_desp_a      = (v_desp_a % (vdp.scrl_size_v * 8));
  v_desp_b      = (v_desp_b % (vdp.scrl_size_v * 8));
  v_cell_a      = v_desp_a >> 3;
  v_cell_b      = v_desp_b >> 3;
  v_desp_a     &= 7;
  v_desp_b     &= 7;
  rd_v_cnt_a    = v_desp_a;
  rd_v_cnt_b    = v_desp_b;

  memset (vid_buffer, vdp.back_color, 0x15000);

  if (v_cell_b < 0) v_cell_b = (vdp.scrl_size_v + v_cell_b);
  if (v_cell_a < 0) v_cell_a = (vdp.scrl_size_v + v_cell_a);

  rd_ptr_scrl_b += (v_cell_b * vdp.scrl_size_h);
  rd_ptr_scrl_a += (v_cell_a * vdp.scrl_size_h);


  for (y = 0; y < (v_lines); y++, rd_v_cnt_a++, rd_v_cnt_b++) {

        h_scrl_b++;
        rd_desp_b       = RorShort (*h_scrl_b++);
        rd_desp_a       = RorShort (*h_scrl_a++);
        h_scrl_a++;

        rd_desp_b       = (-rd_desp_b);
        rd_desp_a       = (-rd_desp_a);
        rd_desp_b       = (rd_desp_b % (vdp.scrl_size_h * 8));
        rd_desp_a       = (rd_desp_a % (vdp.scrl_size_h * 8));

        //if (h_cell_b <= 0) h_cell_b = (vdp.scrl_size_h + h_cell_b);
        //if (h_cell_a <= 0) h_cell_a = (vdp.scrl_size_h + h_cell_a);

        /*if (scrl_b_enable) 
                DoLINE (y+8, rd_ptr_scrl_b, (rd_v_cnt_b&7), rd_desp_b>>3,
                        rd_desp_b&7, vdp.h_cells, vdp.scrl_size_h);

        if (scrl_a_enable)
                DoLINE (y+8, rd_ptr_scrl_a, (rd_v_cnt_a&7), rd_desp_a>>3,
                        rd_desp_a&7, vdp.h_cells, vdp.scrl_size_h);*/

        RenderLine ();
        
        if (!((rd_v_cnt_b+1)%8)) {
                rd_ptr_scrl_b += vdp.scrl_size_h;

                if (((y/8) + v_cell_b + 2) > vdp.scrl_size_v) {
                        rd_ptr_scrl_b = (u_short *)(mem.ram.vram + vdp.base_scrl_b);
                        v_cell_b = 0;
                }
        }

        if (!((rd_v_cnt_a+1)%8)) {
                rd_ptr_scrl_a += vdp.scrl_size_h;

                if (((y/8) + v_cell_a + 2) > vdp.scrl_size_v) {
                        rd_ptr_scrl_a = (u_short *)(mem.ram.vram + vdp.base_scrl_a);
                        v_cell_a = 0;
                }
        }

  }

  if (window_enable) ShowWindow ();

  if (sprs_enable) ShowSprs ();

  if (wait_sync) WaitSync ();

  ShowVGA  ();
}

void RenderVDPLineRaster (void) {

  s_short      *h_scrl;
  s_short      *h_scrl_a;
  s_short      *h_scrl_b;
  u_short      *v_scrl;
  s_short       v_desp_a;
  s_short       v_desp_b;
  s_short       v_cell_a;
  s_short       v_cell_b;
  u_short       v_lines         = vdp.v_cells * 8;
  u_char        hint_cnt        = 0;
  long          y, x;
  s_short       dif_b;
  s_short       dif_a;
  u_short       next;
  u_short       h_beam          = 0;
  u_short       v_beam          = 0;
  int           tmp_cnt;


  memset (vid_buffer, vdp.back_color, 0x15000);

  vdp.drawing           = 1;
  vdp.hv_cnt            = 0;
  rd_buffer_pos         = (u_char *)(v_buffer+(336*8));


  for (y = 0; y < (v_lines); y++) {

        rd_ptr_scrl_a   = (u_short *)(mem.ram.vram + vdp.base_scrl_a);
        rd_ptr_scrl_b   = (u_short *)(mem.ram.vram + vdp.base_scrl_b);
        h_scrl          = (s_short *)(mem.ram.vram + vdp.base_scrl_h);
        v_scrl          = (u_short *)(mem.ram.vsram);
        v_desp_a        = RorShort (*v_scrl++);
        v_desp_b        = RorShort (*v_scrl);

        v_desp_a        = (v_desp_a % (vdp.scrl_size_v * 8));
        v_desp_b        = (v_desp_b % (vdp.scrl_size_v * 8));
        v_cell_a        = v_desp_a / 8;
        v_cell_b        = v_desp_b / 8;
        v_desp_a       %= 8;
        v_desp_b       %= 8;
        rd_v_cnt_a      = (v_desp_a + y);
        rd_v_cnt_b      = (v_desp_b + y);

        if (v_cell_b < 0) v_cell_b = (vdp.scrl_size_v + v_cell_b);
        if (v_cell_a < 0) v_cell_a = (vdp.scrl_size_v + v_cell_a);

        rd_ptr_scrl_b += (v_cell_b * vdp.scrl_size_h);
        rd_ptr_scrl_a += (v_cell_a * vdp.scrl_size_h);

        dif_b = y;
        dif_a = y;

        if ((y + (v_cell_b*8) + v_desp_b + 1) > (vdp.scrl_size_v*8)) {
                dif_b = ((y + (v_cell_b * 8)) - (vdp.scrl_size_v * 8));
                rd_ptr_scrl_b = (u_short *)(mem.ram.vram + vdp.base_scrl_b);
        }
        
        if ((y + (v_cell_a*8) + v_desp_a + 1) > (vdp.scrl_size_v*8)) {
                dif_a = ((y + (v_cell_a * 8)) - (vdp.scrl_size_v * 8));
                rd_ptr_scrl_a = (u_short *)(mem.ram.vram + vdp.base_scrl_a);
        }

        rd_ptr_scrl_b += (((dif_b+v_desp_b)/8) * vdp.scrl_size_h);
        rd_ptr_scrl_a += (((dif_a+v_desp_a)/8) * vdp.scrl_size_h);

        if (vdp.scrl_mode_h == 3) {
                h_scrl_a = (h_scrl + (y * 2));
                h_scrl_b = (h_scrl + (y * 2) + 1);

        } else if (vdp.scrl_mode_h == 2) {
                h_scrl_a = (h_scrl + ((((y * 2)) / 16) * 16));
                h_scrl_b = (h_scrl + (((((y * 2)) / 16) * 16) + 1));

        } else {
                h_scrl_a = h_scrl;
                h_scrl_b = (h_scrl + 1);
        }
        
        rd_desp_b       = (long)RorShort (*h_scrl_b);
        rd_desp_a       = (long)RorShort (*h_scrl_a);

        rd_desp_b       = (-rd_desp_b);
        rd_desp_a       = (-rd_desp_a);
        rd_desp_b       = (rd_desp_b % (vdp.scrl_size_h * 8));
        rd_desp_a       = (rd_desp_a % (vdp.scrl_size_h * 8));


        //if (h_cell_b <= 0) h_cell_b = (vdp.scrl_size_h + h_cell_b);
        //if (h_cell_a <= 0) h_cell_a = (vdp.scrl_size_h + h_cell_a);

        /*      DoLINE (y+8, rd_ptr_scrl_b, (rd_v_cnt_b&7), rd_desp_b>>3, rd_desp_b&7,
                        vdp.h_cells, vdp.scrl_size_h);

                DoLINE (y+8, rd_ptr_scrl_a, (rd_v_cnt_a&7), rd_desp_a>>3, rd_desp_a&7,
                        vdp.h_cells, vdp.scrl_size_h);*/


        RenderLine ();

        if (vdp.hi_enable) {
                if (hint_cnt == (u_char)vdp.reg[10]) {
                        m68k_intr_run = 1;
                        vdp.vdp_sr.horz_blk = 1;
                        Interrupt68k (4);
                        /*for (tmp_cnt = 0; tmp_cnt < 10; tmp_cnt++)
                                Execute_CPU ();*/
                        while (m68k_intr_run) Execute_CPU ();

                        vdp.vdp_sr.horz_blk = 0;
                        hint_cnt = 0;
                } else
                        hint_cnt++;
        }

        v_beam++;
        h_beam++;

        vdp.hv_cnt = 0;

        /*vdp.hv_cnt = v_beam;
        vdp.hv_cnt |= (v_beam << 8);*/

        vdp.hv_cnt |= ((v_beam<<8) & 0xfe);
        vdp.hv_cnt |= ((v_beam>>8)<<8);
        
        vdp.hv_cnt |= (h_beam & 0xfe);
        vdp.hv_cnt |= (h_beam>>8);
  }

  if (window_enable) ShowWindow ();

  if (sprs_enable) ShowSprs ();

  if (wait_sync) WaitSync ();

  vdp.drawing = 0;
  vdp.pal_effect = 0;

  ShowVGA  ();
}


void ShowWindow (void) {

  u_short      *window          = (u_short *)(mem.ram.vram + vdp.base_win);
  u_char        y_window        = ((vdp.win_v_pos) ? (vdp.win_v_pos & 0x7f) : vdp.v_cells);
  u_char        x_window        = ((vdp.win_h_pos) ? (vdp.win_h_pos & 0x7f) : vdp.h_cells);
  u_short       next;
  int           y, x;


  if (!vdp.win_h_pos && !vdp.win_v_pos) return;

  if (!(vdp.win_v_pos & 0x80) && !(vdp.win_h_pos & 0x80)) {

        for (y = 1; y < (y_window+1); y++) {

                for (x = 1; x < (x_window+1); x++) {

                        next = RorShort (*window++);
                        if (next & 0x7ff) DoCELLAsm (next, y*8, x*8);
                }

                if (vdp.h_cells > 32)
                        window += (vdp.scrl_size_h - x_window);
        }

        return;
  }

  if ((vdp.win_v_pos & 0x80) && !(vdp.win_h_pos & 0x80)) {

        window += (y_window * vdp.scrl_size_h);

        for (y = (y_window+1); y < (vdp.v_cells+1); y++) {

                for (x = 1; x < (x_window+1); x++) {

                        next = RorShort (*window++);
                        if (next & 0x7ff) DoCELLAsm (next, y*8, x*8);
                }

                if (vdp.h_cells > 32)
                        window += (vdp.scrl_size_h - x_window);
        }

        return;
  }

  if (!(vdp.win_v_pos & 0x80) && (vdp.win_h_pos & 0x80)) {

        for (y = 1; y < (y_window+1); y++) {

                for (x = (x_window+1); x < (vdp.h_cells+1); x++) {

                        
                        next = RorShort (*window++);
                        if (next & 0x7ff) DoCELLAsm (next, y*8, x*8);
                }

                if (vdp.h_cells > 32)
                        window += (vdp.scrl_size_h - (vdp.h_cells - x_window));
        }

        return;
  }

  if ((vdp.win_v_pos & 0x80) && (vdp.win_h_pos & 0x80)) {

        for (y = (y_window+1); y < (vdp.v_cells+1); y++) {

                for (x = (x_window+1); x < (vdp.h_cells+1); x++) {

                        next = RorShort (*window++);
                        if (next & 0x7ff) DoCELLAsm (next, y*8, x*8);
                }

                if (vdp.h_cells > 32)
                        window += (vdp.scrl_size_h - (vdp.h_cells - x_window));
        }

        return;
  }
}


void (*SPR_FUNC[])() = { PutSprA, PutSprB, PutSprC, PutSprD };


void ShowSprs (void) {

  char         *tmp     = (char *)(mem.ram.vram + vdp.base_spr);
  u_long       *f_spr   = (u_long *)tmp;
  u_long       *p_spr   = f_spr;
  u_long        first;
  u_long        second;
  u_short       mode;

  s_short       x_pos;
  s_short       y_pos;

  u_long        mx      = (vdp.h_cells * 8);
  u_long        my      = (vdp.v_cells * 8);


  //spr_flg = 1;

  while (1) {
        first = RorLong (*p_spr++);
        p_spr++;
        if (!(first & 0xff)) break;
  }

  //p_spr-=2;

  do {
        p_spr-=2;
        
        first = RorLong (*p_spr);
        second = RorLong (*(p_spr+1));

        mode = (second >> 27) & 3;

        y_pos = (first >> 16) & 0xfff;  
        x_pos = second & 0xfff;
        y_pos -= 128;
        x_pos -= 120;

        //if ((x_pos > -8 && x_pos < mx) && (y_pos > 0 && y_pos < my))
                SPR_FUNC[mode] (first, second);

        //p_spr -= 2;

  } while (p_spr > f_spr);

  //spr_flg = 0;
}

void PutSprA (u_long first, u_long second) {

  u_short       v_pos;
  u_short       y_pos;
  u_short       x_pos;

  int           cnt_x, cnt_y;
  int           x_cell, y_cell;
  u_short       size;

  u_short       cnt;


  y_pos = (first >> 16) & 0xfff;

  y_cell = ((first >> 8) & 3) + 1;
  x_cell = ((first >> 10) & 3) + 1;

  v_pos = (second >> 16) & 0xffff;
  x_pos = second & 0xfff;

  cnt = v_pos;

  y_pos = (y_pos % 512);
  x_pos = (x_pos % 512);

  //if (x_pos && y_pos) PrintLog ("SPRA x=%d y=%d", x_pos, y_pos);

  for (cnt_x = 0; cnt_x < x_cell; cnt_x++) {
        for (cnt_y = 0; cnt_y < y_cell; cnt_y++) {
                DoCELLAsm (cnt, ((y_pos-120)+(cnt_y*8)),
                          ((x_pos-120)+(cnt_x*8)));
                cnt++;
        }
  }
}

void PutSprB (u_long first, u_long second) {

  u_short       v_pos;
  u_short       y_pos;
  u_short       x_pos;

  int           cnt_x, cnt_y;
  int           x_cell, y_cell;
  u_short       size;

  u_short       cnt;


  y_pos = (first >> 16) & 0xfff;

  y_cell = ((first >> 8) & 3) + 1;
  x_cell = ((first >> 10) & 3) + 1;

  v_pos = (second >> 16) & 0xffff;
  x_pos = second & 0xfff;

  cnt = v_pos;

  y_pos = (y_pos % 512);
  x_pos = (x_pos % 512);

  for (cnt_x = (x_cell-1); cnt_x > -1; cnt_x--) {
        for (cnt_y = 0; cnt_y < y_cell; cnt_y++) {
                DoCELLAsm (cnt, ((y_pos-120)+(cnt_y*8)),
                          ((x_pos-120)+(cnt_x*8)));
                cnt++;
        }
  }
}

void PutSprC (u_long first, u_long second) {

  u_short       v_pos;
  u_short       y_pos;
  u_short       x_pos;

  int           cnt_x, cnt_y;
  int           x_cell, y_cell;
  u_short       size;

  u_short       cnt;


  y_pos = (first >> 16) & 0xfff;

  y_cell = ((first >> 8) & 3) + 1;
  x_cell = ((first >> 10) & 3) + 1;
  
  v_pos = (second >> 16) & 0xffff;
  x_pos = second & 0xfff;

  cnt = v_pos;

  y_pos = (y_pos % 512);
  x_pos = (x_pos % 512);

  for (cnt_x = 0; cnt_x < x_cell; cnt_x++) {
        for (cnt_y = (y_cell-1); cnt_y > -1; cnt_y--) {
                DoCELLAsm (cnt, ((y_pos-120)+(cnt_y*8)),
                          ((x_pos-120)+(cnt_x*8)));
                cnt++;
        }
  }
}

void PutSprD (u_long first, u_long second) {

  u_short       v_pos;
  u_short       y_pos;
  u_short       x_pos;

  int           cnt_x, cnt_y;
  int           x_cell, y_cell;
  u_short       size;

  u_short       cnt;


  y_pos = (first >> 16) & 0xfff;

  y_cell = ((first >> 8) & 3) + 1;
  x_cell = ((first >> 10) & 3) + 1;

  v_pos = (second >> 16) & 0xffff;
  x_pos = second & 0xfff;

  cnt = v_pos;

  y_pos = (y_pos % 512);
  x_pos = (x_pos % 512);

  for (cnt_x = (x_cell-1); cnt_x > -1; cnt_x--) {
        for (cnt_y = (y_cell-1); cnt_y > -1; cnt_y--) {
                DoCELLAsm (cnt, ((y_pos-120)+(cnt_y*8)),
                          ((x_pos-120)+(cnt_x*8)));
                cnt++;
        }
  }
}

void ShowVGA (void) {

  u_long       *vid     = ((vesa_flg) ? (u_long *)VESA20.lfbl : (u_long *)0xa0000);
  u_long       *src     = (u_long *)vid_buffer;
  int           cnt_y;
  int           cnt_x;
  int           rest    = ((!vdp.cell_mode) ? 10 : 2);
  int           copy    = ((!vdp.cell_mode) ? 64 : 80);
  int           restv   = ((!vdp.cell_mode) ? 8 : 0);

  /*static uclock_t last_clock = 0;
  uclock_t present_clock;
  uclock_t dif_clock;
  u_long fps;
  char cfps[40];

  if (!last_clock)
        last_clock = usec_clock(NULL);
  else {
        present_clock = usec_clock(NULL);
        dif_clock = (present_clock - last_clock);
        last_clock = present_clock;
        fps = (dif_clock*60)/17000;
        sprintf (cfps, "fps=%lu", (120-fps));
        DrawTextGUI (GUI, 100, 200, cfps);
  }*/

  //DrawTextGUI (GUI, 100, 100, "Comeme la Polla! 1234, JAJAJA");

  if (vesa_flg) {
        vid += 640;
        src += 672;
  } else
        src += 1512;

  for (cnt_y = 0; cnt_y < ((vesa_flg) ? 224 : 200); cnt_y++)  {
        src += rest;
        vid += restv;

        //for (cnt_x = 0; cnt_x < copy; cnt_x++)
        //        *vid++ = *src++;
        FlipFpu ((long)src, (long)vid, (copy/4));
        //Flip ((long)src, (long)vid, copy);

        src += (rest + copy);
        vid += (restv + copy);
  }
}

void ShowVGAFull (void) {

  u_long       *vid     = ((vesa_flg) ? (u_long *)VESA20.lfbl : (u_long *)0xa0000);
  u_long       *src     = (u_long *)vid_buffer;
  int           cnt_y;
  int           cnt_x;
  int           rest    = 2;
  int           copy    = 80;
  int           restv   = 0;


  if (vesa_flg) {
        vid += 640;
        src += 672;
  } else
        src += 1512;

  for (cnt_y = 0; cnt_y < ((vesa_flg) ? 224 : 200); cnt_y++)  {
        src += rest;
        vid += restv;

        //for (cnt_x = 0; cnt_x < copy; cnt_x++)
        //        *vid++ = *src++;
        FlipFpu ((long)src, (long)vid, (copy/4));
        //Flip ((long)src, (long)vid, copy);

        src += (rest + copy);
        vid += (restv + copy);
  }
}


