
#include <stdlib.h>
#include <i86.h>
#include <dos.h>
#include <stdio.h>

#include "vesa20.h"


/*******************************MEM*************************************/


struct
     {
     unsigned largestblockavailable;
     unsigned maxiumunlockedpage;
     unsigned largestlockablepage;
     unsigned linearaddressspace;
     unsigned freepagesavailables;
     unsigned totalphysicalpages;
     unsigned freelinearadressspace;
     unsigned sizeofpagefile;
     unsigned reserved[3];
     }    meminfo;


typedef struct _rmem_ rmem;


void pm_getinfo(void)
{
union REGS regs;
struct SREGS sregs;

regs.x.eax=0x500;
memset(&sregs,0,sizeof(sregs));
sregs.es=FP_SEG(&meminfo);
regs.x.edi=FP_OFF(&meminfo);
int386x(0x31,&regs,&regs,&sregs);
}


long pm_getmem(unsigned long size, rmem *a)
{
union REGS regs;

regs.x.eax=0x501;
regs.x.ebx=(size&0xffff0000)>>16;
regs.x.ecx=(size&0x0000ffff);
int386(0x31,&regs,&regs);
if(regs.x.cflag==0)
 {
 long temp=((regs.x.ebx&0x0000ffff)<<16)|(regs.x.ecx&0x0000ffff);
 a->linear=temp;
 a->handle=((regs.x.esi&0x0000ffff)<<16)|(regs.x.edi&0x0000ffff);
 a->size=size;
 a->ptr=(unsigned char *)temp;
 a->ptrs=(unsigned short *)temp;
 a->ptrl=(unsigned long *)temp;
 return 0;
 }
return 1;
}

long pm_freemem(rmem *a)
{
union REGS regs;

regs.x.eax=0x502;
regs.x.esi=(a->handle&0xffff0000)>>16;
regs.x.edi=(a->handle&0x0000ffff);

int386(0x31,&regs,&regs);
return regs.x.cflag;
}

long pm_resizemem(unsigned long size, rmem *a)
{
union REGS regs;
struct SREGS sregs;

regs.x.eax=0x503;
regs.x.ebx=(size&0xffff0000)>>16;
regs.x.ecx=size&0x0000ffff;
regs.x.esi=(a->handle&0xffff0000)>>16;
regs.x.edi=a->handle&0x0000ffff;
int386(0x31,&regs,&regs);
if(regs.x.cflag==0) {return 0;a->size=size;}
return 1;
}




long pm_mapmem(unsigned long physical,unsigned long size, rmem *a)
{
union REGS regs;
struct SREGS sregs;

regs.x.eax=0x800;
regs.x.ebx=(physical&0xffff0000)>>16;
regs.x.ecx=(physical&0x0000ffff);
regs.x.esi=(size&0xffff0000)>>16;
regs.x.edi=(size&0x0000ffff);
int386(0x31,&regs,&regs);
if(regs.x.cflag==0)
   {
   a->linear=((regs.x.ebx&0x0000ffff)<<16)|(regs.x.ecx&0x0000ffff);
   a->size=size;
   return 0;
   }
return 1;
}


long pm_freemapmem(rmem *a)
{
union REGS regs;
struct SREGS sregs;

regs.x.eax=0x801;
regs.x.ebx=(a->linear&0xffff0000)>>16;
regs.x.ecx=(a->linear&0x0000ffff);
int386(0x31,&regs,&regs);
return regs.x.cflag;
}





/******************************MEMDOS******************************/

/*typedef struct
    {
       long linear;
      short segment;
       long selector;
       long size;
    } memdos;*/

long pm_getmemdos(unsigned long rmem, memdos *a)
{
union REGS regs;

regs.x.eax=0x100;
regs.x.ebx=(rmem>>4)+1;
int386(0x31,&regs,&regs);
if(regs.x.cflag==0)
 {
  a->segment=regs.x.eax&0x0000ffff;
  a->selector=regs.x.edx;
  a->linear=a->segment<<4;
  a->size=rmem;
  return 0;
 }
return 1;
}

long pm_freememdos(memdos *a)
{
union REGS regs;

regs.x.eax=0x101;
regs.x.edx=a->selector;
int386(0x31,&regs,&regs);
return regs.x.cflag;
}


long pm_resizememdos(unsigned long rmem, memdos *a)
{
union REGS regs;

regs.x.eax=0x102;
regs.x.edx=a->selector;
int386(0x31,&regs,&regs);
if(regs.x.cflag==0) {a->size=rmem;return 0;};
return 1;
}


/*
102h: modificar

200h; obtener direcc controlador int del modo real
201h; fijar controlador int del modo real

300h; simular int de modo real
301h; llamar rut de modo real

400h; numero de version

501h; alojar memoria en la extended memory
502h; liberar
503h; modificar
504h; convertir de fisica a lineal

*/


/************************************INTS*********************************/
  

typedef struct
  {
   long edi,esi,ebp,RESERVED,ebx,edx,ecx,eax;
   short flags,es,ds,fs,gs,ip,cs,sp,ss;
   union REGS r;
   struct SREGS s;

  } rmregs;

#define pm_int(a,b)                         \
    b.r.x.eax=0x300;                        \
    b.r.x.ebx=a;                            \
    b.r.x.ecx=0;                            \
    b.s.es=FP_SEG(&b);                      \
    b.r.x.edi=FP_OFF(&b);                   \
    int386x(0x31,&b.r,&b.r,&b.s);           \


char env_id[50];
short env_type;

char machine_setup_env()
{
union REGS r;

r.x.eax=0x160a;
r.x.ebx=0x0;
r.x.ecx=0x0;
int386(0x2f,&r,&r);

if(r.x.eax==0) {
                char temp[10];
                sprintf(&env_id,"Windows ");
                if(r.w.bx==0x400) sprintf(&temp,"95 ");
                             else sprintf(&temp,"%02x.%02x ",r.h.bh,r.h.bl);
                strcat(&env_id,temp);
                if(r.w.cx==2) strcat(&env_id,"detected in standard mode");
                         else strcat(&env_id,"detected in enhanced mode");
                return env_type=95;
               }
         else  {
                r.x.eax=0x3000;
                int386(0x21,&r,&r);
                sprintf(&env_id,"DOS %x detected",r.h.al);
                return env_type=0;
               }
}


short cpu_type,cpu_mmx;
long cpu_name[6];
char cpu_id[64];

char machine_setup_cpu(void);
#pragma aux machine_setup_cpu = \
".586"\
"pushfd"\
"pop eax"\
"mov ecx,eax"\
"xor eax,200000h"\
"push eax"\
"popfd"\
"pushfd"\
"pop eax"\
"xor eax,ecx"\
"jne pentium"\
"mov [cpu_type],486"\
"xor eax,eax"\
"ret"\
"pentium:"\
"xor eax,eax"\
"cpuid"\
"mov [cpu_type],586"\
"mov [cpu_name],ebx"\
"mov [cpu_name+4],edx"\
"mov [cpu_name+8],ecx"\
"mov [cpu_name+13],0"\
"inc eax"\
"cpuid"\
"shr eax,12"\
"and eax,3"\
"ends:"\
"mov [cpu_mmx],ax"\

void MachineSetup()
{
machine_setup_env();
//machine_setup_cpu();

//cpu_type+=cpu_mmx;

cpu_type = 586;

/*switch(cpu_type)
{
case 587: sprintf(cpu_id,"Pentium w/MMX (%s)",cpu_name);
          break;

case 586: sprintf(cpu_id,"Pentium (%s)",cpu_name);
          break;

case 486: sprintf(cpu_id,"486");
          break;

default:  sprintf(cpu_id,"Unknown CPU");
          cpu_type = 0;
          break;
}*/

strcpy (cpu_type, env_type);

}


struct _vesa20_ VESA20;

#define page1 0
#define page2 1
#define page3 2
#define page4 3
#define page5 4
#define page6 5
#define page7 6
#define page8 7
#define page9 8


/******************************VESA 2.0************************************/

long Vesa20Setup(void)
{
rmregs r;
memdos m;
short a;
char *d,*s;
char temp[80];
char vberequest[]="VBE2";
union  REGS  regs;
struct SREGS sregs;

struct _vesa20_int_ {
       char id[4];
      short version;
       long stringptr;
       long capabilities;
       long videoptr;
      short memory;
       long revisionptr;
       long vendorptr;
       long nameptr;
       long name2ptr;
       char reserved[222];
       char oemdata[256];
       } VESA20INT;


  if(pm_getmemdos(512,&m)==1) return 1;

  s=(char *)m.linear;
  d=(char *)&vberequest[0];
  for(a=0;a<3;a++) (*s++)=(*d++);

  memset(&r,0,sizeof(r));
  r.eax=0x4F00;
  r.es=m.segment;
  r.edi=0;
  pm_int(0x10,r);

  /*s=(char *)m.linear;
  d=(char *)&VESA20INT;
  for(a=0;a<200;a++) (*d++)=(*s++);*/

  memcpy (&VESA20INT, (char *)m.linear, sizeof (struct _vesa20_int_));

  s=(char *)(((VESA20INT.stringptr&0xffff0000)>>12)|(VESA20INT.stringptr&0xffff));
  d=(char *)&temp;
  while((*s)!=0) (*d++)=(*s++);
  *d++=0;

  VESA20.memory=VESA20INT.memory<<6;

  VESA20.version=VESA20INT.version;
  VESA20INT.version=0;
  if(VESA20.version>0x200)
    {if(strncmp(&temp,"VORTEX",6)==0) VESA20.version=0x0102;}

  sprintf(VESA20.id,"%s %c.%c found: %s with %dKb",VESA20INT.id,(VESA20.version>>8)+48,(VESA20.version&0xff)+48, temp, VESA20.memory);

  VESA20.modeptr=(short *)((((VESA20INT.videoptr&0xffff0000)>>12)|(VESA20INT.videoptr&0xffff)));//+64;
  //VESA20.modeptr = (short *)((VESA20INT.videoptr&0xffff)<<4);

  pm_freememdos(&m);

  return 0x1ff/VESA20.version;
}



long vesa20_getmodeinfo(unsigned short mode)
{
rmregs rx;
memdos n;
short a;
char *d, *s;
union REGS regs;
struct SREGS sregs;

struct{
      short attrib;
       char winaattrib,winbattrib;
      short wingran,winsize,winaseg,winbseg;
       long winptr;
      short bytesperscanline;
      short x,y;
       char xchar,ychar,planes,bpp,banks,memmodel,banksize,images,reserved2;
       char rms,rfp,gms,gfp,bms,bfp,rsms,rsfp,directcolor;
       long phyaddr,memoffset;
      short memsize;
       char reserved[206];
      } VESA20modeint;


if(pm_getmemdos(512,&n)==1) return 1;

memset(&rx,0,sizeof(rx));
rx.eax=0x4f01;
rx.ecx=(unsigned long)(unsigned short)mode;
rx.es=n.segment;
rx.edi=0;
pm_int(0x10,rx);

s=(char *)n.linear;
d=(char *)&VESA20modeint;
 
for(a=0;a<sizeof(VESA20modeint);a++) (*d++)=(*s++);

VESA20.bpp=VESA20modeint.bpp;
VESA20.memsize=VESA20modeint.memsize;
VESA20.model=VESA20modeint.memmodel;
VESA20.bytesperscanline=VESA20modeint.bytesperscanline;
VESA20.phyaddr=VESA20modeint.phyaddr;
VESA20.memoffset=VESA20modeint.memoffset;

if(VESA20modeint.memmodel!=0)
 { VESA20.x=VESA20modeint.x; VESA20.y=VESA20modeint.y; }
 else { VESA20.x=VESA20modeint.xchar; VESA20.y=VESA20modeint.ychar; }

VESA20.page=0;

return pm_freememdos(&n);
}


void setvideo(long mode)
{
union REGS regs;

if(mode>=0x100)
     {
     regs.x.eax=0x4f02;
     regs.x.ebx=mode;
     int386(0x10,&regs,&regs);
     }
else {
     regs.x.eax=mode;
     int386(0x10,&regs,&regs);
     }
}


void vesa20_setscanwidth(unsigned long pix)
{
union REGS regs;
regs.x.eax=0x4f06;
regs.x.ebx=0;
regs.x.ecx=pix;
int386(0x10,&regs,&regs);
VESA20.scanwidth=pix;
}

#define vesa20_closevideomode() pm_freemapmem(&VESA20.mem);


void Vesa20CloseVideoMode (void) {

  vesa20_closevideomode ();
}

long vesa20_setdirectvideomode(short x, short y, char bpp, short m)
{
union REGS regs;

vesa20_getmodeinfo(m);

if(VESA20.x==x) if(VESA20.y==y) if(VESA20.bpp==bpp) if(VESA20.model==6||VESA20.model==4) {

        setvideo(0x4000|m);
        pm_mapmem(VESA20.phyaddr,VESA20.memory<<10,&VESA20.mem);
        VESA20.lfb=(unsigned char *)VESA20.mem.linear;
        VESA20.lfbs=(unsigned short *)VESA20.mem.linear;
        VESA20.lfbl=(unsigned long *)VESA20.mem.linear;

        regs.x.eax=0x4f06;
        regs.x.ebx=1;
        regs.x.ecx=0;
        int386(0x10,&regs,&regs);

        vesa20_setscanwidth(regs.x.ecx);

        return 1;
}

return 0;
}

long Vesa20SetDirectVideoMode (short x, short y, char bpp, short m) {

  return (vesa20_setdirectvideomode (x, y, bpp, m));
}

/*long Vesa20SetVideoMode(short x, short y, char bpp)
{
short *s=(short *)(VESA20.modeptr);

while(*s!=-1)
      {
      vesa20_getmodeinfo((unsigned short)*s);
      PrintELog ("VESA mode support: %dx%dx%d mode %lx", VESA20.x, VESA20.y,
                 VESA20.bpp, (unsigned short) *s);
      if(VESA20.x==x)
       {
       if(VESA20.y==y)
        {
        if(VESA20.bpp==bpp)
         {
        //if(VESA20.model==6||VESA20.model==4)
        if (1)
          {
           union REGS regs;

           setvideo(0x4000|(*s));
           pm_mapmem(VESA20.phyaddr,VESA20.memory<<10,&VESA20.mem);
           VESA20.lfb=(unsigned char *)VESA20.mem.linear;
           VESA20.lfbs=(unsigned short *)VESA20.mem.linear;
           VESA20.lfbl=(unsigned long *)VESA20.mem.linear;

           regs.x.eax=0x4f06;
           regs.x.ebx=1;
           regs.x.ecx=0;
           int386(0x10,&regs,&regs);

           VESA20.mode=(*s);
           vesa20_setscanwidth(regs.x.ecx);

           return 0;
           }
         }
        }
       }

      s++;
      }


//vesa20_setdirectvideomode(mode);
//if(VESA20.x==x) if(VESA20.y==y) if(VESA20.bpp==bpp) if(VESA20.model==6||VESA20.model==4) return 0;
return 1;
}*/

long Vesa20SetVideoMode(short x, short y, char bpp)
{
short s=0x100;

while(s < 0x300)
      {
      vesa20_getmodeinfo(s);
      //PrintELog ("VESA mode support: %dx%dx%d mode %lx", VESA20.x, VESA20.y,
      //         VESA20.bpp, (unsigned short) s);
      if(VESA20.x==x)
       {
       if(VESA20.y==y)
        {
        if(VESA20.bpp==bpp)
         {
        //if(VESA20.model==6||VESA20.model==4)
        if (1)
          {
           union REGS regs;

           setvideo(0x4000|s);
           pm_mapmem(VESA20.phyaddr,VESA20.memory<<10,&VESA20.mem);
           VESA20.lfb=(unsigned char *)VESA20.mem.linear;
           VESA20.lfbs=(unsigned short *)VESA20.mem.linear;
           VESA20.lfbl=(unsigned long *)VESA20.mem.linear;

           regs.x.eax=0x4f06;
           regs.x.ebx=1;
           regs.x.ecx=0;
           int386(0x10,&regs,&regs);

           VESA20.mode=s;
           vesa20_setscanwidth(regs.x.ecx);

           return 0;
           }
         }
        }
       }

      s++;
      }


//vesa20_setdirectvideomode(mode);
//if(VESA20.x==x) if(VESA20.y==y) if(VESA20.bpp==bpp) if(VESA20.model==6||VESA20.model==4) return 0;
return 1;
}



void vesa20_setwindow(long x, long y)
{
union REGS regs;

regs.x.eax=0x4f07;
regs.x.ebx=0;
regs.x.ecx=x;
regs.x.edx=y;
int386(0x10,&regs,&regs);
}


void vesa20_waitretrace(void)
{
while((inp(0x3da)&8)!=0) ;
while((inp(0x3da)&8)==0) ;
while((inp(0x3da)&8)!=0) ;
}

void vesa20_makehalfheight()
 {
 char axc;
 outp(0x3d4,9);
 axc=(inp(0x3d5)+1);
 outpw(0x3d4,(short)((axc<<8)|9));
 }

void Vesa20ClearMem()
{
memset((char *)VESA20.mem.linear,0L,VESA20.memory*1024);
}

void Vesa20ClearPage(short page)
{
memset((char *)(VESA20.mem.linear+(VESA20.x*VESA20.y*page*((VESA20.bpp+1)/8))),0L,VESA20.x*VESA20.y*((VESA20.bpp+1)/8));
}


#define vesa20_setpixel(zx,zx2,zx3,zx4)  VESA20.lfb[(zx+(zx2*VESA20.x))*(zx4+1)]=zx3;
#define vesa20_setpixels(zx,zx2,zx3,zx4) VESA20.lfbs[(zx+(zx2*VESA20.x))*(zx4+1)]=zx3;
#define vesa20_setpixell(zx,zx2,zx3,zx4) VESA20.lfbl[(zx+(zx2*VESA20.x))*(zx4+1)]=zx3;


void vesa20_quicksetpage(short page)
{
union REGS regs;

regs.x.eax=0x4f07;
regs.x.ebx=0;
regs.x.ecx=0;
regs.x.edx=VESA20.y*page;
int386(0x10,&regs,&regs);
}

void vesa20_quicksetpagewithretrace(short page)
{
union REGS regs;

regs.x.eax=0x4f07;
regs.x.ebx=0x80;
regs.x.ecx=0;
regs.x.edx=VESA20.y*page;
int386(0x10,&regs,&regs);
}

#define quickoffset (VESA20.x*VESA20.y*VESA20.page)


#define m80x25 0x003
#define m80x60 0x108
#define m132x25 0x109
#define m132x43 0x10A
#define m132x50 0x10B
#define m132x60 0x10C

